-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 35 to version 36
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Microsoft SQL Server
-- ---------------------------------------------------------------------------------
-- Copyright:
-- ivyTeam AG, Alpenstrasse 9, 6304 Zug
-- ---------------------------------------------------------------------------------


-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ApplicationDeleteTrigger
GO

-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_UserDeleteTrigger
GO

-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_TaskStartDeleteTrigger
GO

-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_TaskDeleteTrigger
GO

-- Create new added tables
CREATE TABLE IWA_TaskSignalEventReceiver
(
  TaskSignalEventId BIGINT NOT NULL,
  WaitingTaskId BIGINT NOT NULL,
  SignalCodePattern VARCHAR(200) NOT NULL,
  SignaledTaskTaskStartId BIGINT NOT NULL REFERENCES IWA_TaskStart(TaskStartId) ON DELETE CASCADE,
  StartedSignaledTaskId BIGINT NULL,
  PRIMARY KEY (TaskSignalEventId)
)
GO

CREATE INDEX IWA_TskSigEvntRcvr_WtingTaskId
ON IWA_TaskSignalEventReceiver (WaitingTaskId)
GO

CREATE INDEX IWA_TskSigEvntRcvr_StrtSgTskId
ON IWA_TaskSignalEventReceiver (StartedSignaledTaskId)
GO

CREATE TABLE IWA_SignaledTask
(
  SignaledTaskId BIGINT NOT NULL,
  SignalCodePattern VARCHAR(200) NOT NULL,
  ReceivedSignalEventId BIGINT NULL,
  PRIMARY KEY (SignaledTaskId)
)
GO

CREATE INDEX IWA_SigTask_RecvdSignalEventId
ON IWA_SignaledTask (ReceivedSignalEventId)
GO

CREATE TABLE IWA_SignalEvent
(
  SignalEventId BIGINT NOT NULL,
  ApplicationId BIGINT NOT NULL,
  SignalCode VARCHAR(200) NOT NULL,
  SentTimestamp DATETIME NOT NULL,
  SentByUserName VARCHAR(200) NULL,
  SentByUserId BIGINT NULL,
  SentByTaskId BIGINT NULL,
  SentByProcessElementPid VARCHAR(200) NULL,
  PRIMARY KEY (SignalEventId)
)
GO

CREATE INDEX IWA_SignalEvent_SignalCode
ON IWA_SignalEvent (SignalCode)
GO

CREATE INDEX IWA_SignalEvent_SentTimestamp
ON IWA_SignalEvent (SentTimestamp)
GO

CREATE INDEX IWA_SignalEvent_SentByTaskId
ON IWA_SignalEvent (SentByTaskId)
GO

CREATE INDEX IWA_SignalEvent_SentByUserId
ON IWA_SignalEvent (SentByUserId)
GO

CREATE TABLE IWA_SignalEventData
(
  SignalEventId BIGINT NOT NULL,
  SignalData IMAGE NOT NULL,
  PRIMARY KEY (SignalEventId)
)
GO

CREATE TABLE IWA_StartSignalEventElement
(
  TaskStartId BIGINT NOT NULL,
  SignalCodePattern VARCHAR(200) NOT NULL,
  PRIMARY KEY (TaskStartId)
)
GO

CREATE INDEX IWA_StrtSigEvntElmnt_SgCdPttrn
ON IWA_StartSignalEventElement (SignalCodePattern)
GO


-- Create trigger which depend on new added table
CREATE TRIGGER IWA_SignaledTaskDeleteTrigger
  ON IWA_SignaledTask FOR DELETE AS

  UPDATE IWA_TaskSignalEventReceiver  SET IWA_TaskSignalEventReceiver.StartedSignaledTaskId=NULL
  FROM IWA_TaskSignalEventReceiver, deleted
  WHERE IWA_TaskSignalEventReceiver.StartedSignaledTaskId = deleted.SignaledTaskId


GO


-- Create trigger which depend on new added table
CREATE TRIGGER IWA_SignalEventDeleteTrigger
  ON IWA_SignalEvent FOR DELETE AS

  UPDATE IWA_SignaledTask  SET IWA_SignaledTask.ReceivedSignalEventId=NULL
  FROM IWA_SignaledTask, deleted
  WHERE IWA_SignaledTask.ReceivedSignalEventId = deleted.SignalEventId

  DELETE IWA_SignalEventData FROM IWA_SignalEventData, deleted
  WHERE IWA_SignalEventData.SignalEventId = deleted.SignalEventId


GO


-- Drop unique constraint which depend on changed columns or was deleted
-- Store Procedure to drop a unique constraint
CREATE PROCEDURE IWA_Drop_Unique
@tablename varchar(100)
AS
DECLARE @parentid integer
DECLARE @uqname varchar(100)
DECLARE table_cursor CURSOR FOR SELECT id FROM sysobjects WHERE name = @tablename
OPEN  table_cursor
FETCH NEXT FROM table_cursor INTO @parentid
IF @@FETCH_STATUS<>0
BEGIN
  RAISERROR ('TABLE %s not found in table sysobjects', 16, 1, @tablename)
  CLOSE table_cursor
  DEALLOCATE table_cursor
  RETURN
END
DECLARE uq_cursor CURSOR FOR
SELECT name from sysobjects WHERE parent_obj = @parentid AND xtype = 'UQ'
CLOSE table_cursor
DEALLOCATE table_cursor
OPEN uq_cursor
FETCH NEXT FROM uq_cursor INTO @uqname
IF @@FETCH_STATUS<>0
BEGIN
  RAISERROR('Unique constraint of table %s not found in table sysobjects', 16, 1, @tablename);
  CLOSE uq_cursor
  DEALLOCATE uq_cursor
  RETURN
END
WHILE @@FETCH_STATUS=0
BEGIN
  EXEC('ALTER TABLE '+@tablename+' DROP CONSTRAINT '+@uqname)
  FETCH NEXT FROM uq_cursor INTO @uqname
END
CLOSE uq_cursor
DEALLOCATE uq_cursor
GO

EXECUTE IWA_Drop_Unique 'IWA_Library'
GO
select null
GO
DECLARE @defname VARCHAR(100), @cmd VARCHAR(1000)
SET @defname = 
(SELECT name
FROM sysobjects so JOIN sysconstraints sc
ON so.id = sc.constid
WHERE object_name(so.parent_obj) = 'IWA_Library'
AND so.xtype = 'D'
AND sc.colid =
 (SELECT colid FROM syscolumns
 WHERE id = object_id('dbo.IWA_Library') AND
 name = 'Version'))
SET @cmd = 'ALTER TABLE IWA_Library DROP CONSTRAINT '
+ @defname
EXEC(@cmd)

GO

-- Changed columns of table IWA_Library
ALTER TABLE IWA_Library ALTER COLUMN Version VARCHAR(50) NOT NULL
GO
ALTER TABLE IWA_Library ADD CONSTRAINT DEFIWA_LibraryVersion  DEFAULT '' FOR Version
GO

-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_Library ADD UNIQUE (ProcessModelVersionId)
GO
ALTER TABLE IWA_Library ADD UNIQUE (ApplicationId, Id, Version)
GO


-- Drop unique constraint which depend on changed columns or was deleted
EXECUTE IWA_Drop_Unique 'IWA_LibraryVersionSpec'
GO
DECLARE @defname VARCHAR(100), @cmd VARCHAR(1000)
SET @defname = 
(SELECT name
FROM sysobjects so JOIN sysconstraints sc
ON so.id = sc.constid
WHERE object_name(so.parent_obj) = 'IWA_LibraryVersionSpec'
AND so.xtype = 'D'
AND sc.colid =
 (SELECT colid FROM syscolumns
 WHERE id = object_id('dbo.IWA_LibraryVersionSpec') AND
 name = 'Version'))
SET @cmd = 'ALTER TABLE IWA_LibraryVersionSpec DROP CONSTRAINT '
+ @defname
EXEC(@cmd)

GO

-- Changed columns of table IWA_LibraryVersionSpec
ALTER TABLE IWA_LibraryVersionSpec ALTER COLUMN Version VARCHAR(50) NOT NULL
GO
ALTER TABLE IWA_LibraryVersionSpec ADD CONSTRAINT DEFIWA_LibraryVersionSpecVersion  DEFAULT '' FOR Version
GO

-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_LibraryVersionSpec ADD UNIQUE (LibrarySpecificationId, Minimum)
GO


-- Create new indexes of table IWA_UserLocation
CREATE INDEX IWA_UserLocation_UserId
ON IWA_UserLocation (UserId)
GO


-- Create new indexes of table IWA_TaskLocation
CREATE INDEX IWA_TaskLocation_TaskId
ON IWA_TaskLocation (TaskId)
GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ApplicationDeleteTrigger
  ON IWA_Application FOR DELETE AS

  DELETE IWA_ApplicationProperty FROM IWA_ApplicationProperty, deleted
  WHERE IWA_ApplicationProperty.ApplicationId = deleted.ApplicationId

  DELETE IWA_Environment FROM IWA_Environment, deleted
  WHERE IWA_Environment.ApplicationId = deleted.ApplicationId

  DELETE IWA_GlobalVariable FROM IWA_GlobalVariable, deleted
  WHERE IWA_GlobalVariable.ApplicationId = deleted.ApplicationId

  DELETE IWA_WebService FROM IWA_WebService, deleted
  WHERE IWA_WebService.ApplicationId = deleted.ApplicationId

  DELETE IWA_ExternalNamingAndDirectory FROM IWA_ExternalNamingAndDirectory, deleted
  WHERE IWA_ExternalNamingAndDirectory.ApplicationId = deleted.ApplicationId

  DELETE IWA_ExternalDatabase FROM IWA_ExternalDatabase, deleted
  WHERE IWA_ExternalDatabase.ApplicationId = deleted.ApplicationId

  DELETE IWA_ProcessModel FROM IWA_ProcessModel, deleted
  WHERE IWA_ProcessModel.ApplicationId = deleted.ApplicationId

  DELETE IWA_Role FROM IWA_Role, deleted
  WHERE IWA_Role.ApplicationId = deleted.ApplicationId

  DELETE IWA_User FROM IWA_User, deleted
  WHERE IWA_User.ApplicationId = deleted.ApplicationId

  DELETE IWA_SignalEvent FROM IWA_SignalEvent, deleted
  WHERE IWA_SignalEvent.ApplicationId = deleted.ApplicationId

  DELETE IWA_ContentManagementSystem FROM IWA_ContentManagementSystem, deleted
  WHERE IWA_ContentManagementSystem.ApplicationId = deleted.ApplicationId

  DELETE IWA_SecurityDescriptor FROM IWA_SecurityDescriptor, deleted
  WHERE IWA_SecurityDescriptor.SecurityDescriptorId = deleted.SecurityDescriptorId


GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_UserDeleteTrigger
  ON IWA_User FOR DELETE AS

  UPDATE IWA_Task  SET IWA_Task.State=9, IWA_Task.FailedTimeoutTimestamp=NULL, IWA_Task.WorkerUserId=NULL, IWA_Task.WorkerUserName=NULL
  FROM IWA_Task, deleted
  WHERE ((IWA_Task.ActivatorUserId = deleted.UserId AND IWA_Task.IsExpired = 0) OR (IWA_Task.ExpiryActivatorUserId = deleted.UserId AND IWA_Task.IsExpired = 1)) AND (IWA_Task."State" = 3 OR IWA_Task."State" = 4 OR IWA_Task."State" = 8 OR IWA_Task."State" = 10)

  UPDATE IWA_Task  SET IWA_Task.State=4, IWA_Task.WorkerUserName=NULL
  FROM IWA_Task, deleted
  WHERE IWA_Task.WorkerUserId = deleted.UserId AND IWA_Task."State" = 8

  DELETE IWA_UserRole FROM IWA_UserRole, deleted
  WHERE IWA_UserRole.UserId = deleted.UserId

  DELETE IWA_UserProperty FROM IWA_UserProperty, deleted
  WHERE IWA_UserProperty.UserId = deleted.UserId

  DELETE IWA_RichDialogUserContext FROM IWA_RichDialogUserContext, deleted
  WHERE IWA_RichDialogUserContext.UserId = deleted.UserId

  DELETE IWA_UserAbsence FROM IWA_UserAbsence, deleted
  WHERE IWA_UserAbsence.UserId = deleted.UserId

  DELETE IWA_UserSubstitute FROM IWA_UserSubstitute, deleted
  WHERE IWA_UserSubstitute.UserId = deleted.UserId

  DELETE IWA_UserSubstitute FROM IWA_UserSubstitute, deleted
  WHERE IWA_UserSubstitute.SubstituteUserId = deleted.UserId

  UPDATE IWA_StartElement  SET IWA_StartElement.ActivatorUserId=NULL
  FROM IWA_StartElement, deleted
  WHERE IWA_StartElement.ActivatorUserId = deleted.UserId

  UPDATE IWA_Case  SET IWA_Case.CreatorUserId=NULL
  FROM IWA_Case, deleted
  WHERE IWA_Case.CreatorUserId = deleted.UserId

  UPDATE IWA_Task  SET IWA_Task.WorkerUserId=NULL
  FROM IWA_Task, deleted
  WHERE IWA_Task.WorkerUserId = deleted.UserId

  UPDATE IWA_Task  SET IWA_Task.ActivatorUserId=NULL
  FROM IWA_Task, deleted
  WHERE IWA_Task.ActivatorUserId = deleted.UserId

  UPDATE IWA_Task  SET IWA_Task.ExpiryActivatorUserId=NULL
  FROM IWA_Task, deleted
  WHERE IWA_Task.ExpiryActivatorUserId = deleted.UserId

  UPDATE IWA_WorkflowEvent  SET IWA_WorkflowEvent.UserId=NULL
  FROM IWA_WorkflowEvent, deleted
  WHERE IWA_WorkflowEvent.UserId = deleted.UserId

  UPDATE IWA_Note  SET IWA_Note.UserId=NULL
  FROM IWA_Note, deleted
  WHERE IWA_Note.UserId = deleted.UserId

  DELETE IWA_UserLocation FROM IWA_UserLocation, deleted
  WHERE IWA_UserLocation.UserId = deleted.UserId

  UPDATE IWA_SignalEvent  SET IWA_SignalEvent.SentByUserId=NULL
  FROM IWA_SignalEvent, deleted
  WHERE IWA_SignalEvent.SentByUserId = deleted.UserId

  UPDATE IWA_PageArchive  SET IWA_PageArchive.UserId=NULL
  FROM IWA_PageArchive, deleted
  WHERE IWA_PageArchive.UserId = deleted.UserId

  UPDATE IWA_SecurityDescriptor  SET IWA_SecurityDescriptor.OwnerUserId=NULL
  FROM IWA_SecurityDescriptor, deleted
  WHERE IWA_SecurityDescriptor.OwnerUserId = deleted.UserId

  DELETE IWA_AccessControl FROM IWA_AccessControl, deleted
  WHERE IWA_AccessControl.UserId = deleted.UserId


GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_TaskStartDeleteTrigger
  ON IWA_TaskStart FOR DELETE AS

  DELETE IWA_StartElement FROM IWA_StartElement, deleted
  WHERE IWA_StartElement.TaskStartId = deleted.TaskStartId

  DELETE IWA_StartEventElement FROM IWA_StartEventElement, deleted
  WHERE IWA_StartEventElement.TaskStartId = deleted.TaskStartId

  DELETE IWA_WebServiceProcStartElement FROM IWA_WebServiceProcStartElement, deleted
  WHERE IWA_WebServiceProcStartElement.TaskStartId = deleted.TaskStartId

  DELETE IWA_IntermediateEventElement FROM IWA_IntermediateEventElement, deleted
  WHERE IWA_IntermediateEventElement.TaskStartId = deleted.TaskStartId

  DELETE IWA_StartSignalEventElement FROM IWA_StartSignalEventElement, deleted
  WHERE IWA_StartSignalEventElement.TaskStartId = deleted.TaskStartId


GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_TaskDeleteTrigger
  ON IWA_Task FOR DELETE AS

  UPDATE IWA_Case  SET IWA_Case.CreatorTaskId=NULL
  FROM IWA_Case, deleted
  WHERE IWA_Case.CreatorTaskId = deleted.TaskId

  DELETE IWA_TaskData FROM IWA_TaskData, deleted
  WHERE IWA_TaskData.TaskId = deleted.TaskId

  DELETE IWA_WorkflowEvent FROM IWA_WorkflowEvent, deleted
  WHERE IWA_WorkflowEvent.TaskId = deleted.TaskId

  DELETE IWA_IntermediateEvent FROM IWA_IntermediateEvent, deleted
  WHERE IWA_IntermediateEvent.TaskId = deleted.TaskId

  DELETE IWA_TaskNote FROM IWA_TaskNote, deleted
  WHERE IWA_TaskNote.TaskId = deleted.TaskId

  DELETE IWA_TaskAdditionalProperty FROM IWA_TaskAdditionalProperty, deleted
  WHERE IWA_TaskAdditionalProperty.TaskId = deleted.TaskId

  DELETE IWA_TaskLocation FROM IWA_TaskLocation, deleted
  WHERE IWA_TaskLocation.TaskId = deleted.TaskId

  DELETE IWA_TaskSignalEventReceiver FROM IWA_TaskSignalEventReceiver, deleted
  WHERE IWA_TaskSignalEventReceiver.WaitingTaskId = deleted.TaskId

  DELETE IWA_SignaledTask FROM IWA_SignaledTask, deleted
  WHERE IWA_SignaledTask.SignaledTaskId = deleted.TaskId

  UPDATE IWA_SignalEvent  SET IWA_SignalEvent.SentByTaskId=NULL
  FROM IWA_SignalEvent, deleted
  WHERE IWA_SignalEvent.SentByTaskId = deleted.TaskId

  DELETE IWA_PageArchive FROM IWA_PageArchive, deleted
  WHERE IWA_PageArchive.TaskId = deleted.TaskId


GO

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0
GO

-- Drop temporary created stored procedures needed for conversion
DROP PROCEDURE IWA_Drop_Unique
GO

-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=36
GO
