-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 38 to version 39
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Microsoft SQL Server
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------


-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ApplicationDeleteTrigger
GO

-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_EnvironmentDeleteTrigger
GO

-- Drop trigger of no longer exisiting table
DROP TRIGGER IWA_RestClientDeleteTrigger
GO

-- Drop no longer exisiting table
DROP TABLE IWA_RestClientProperty
GO

-- Drop no longer exisiting table
DROP TABLE IWA_RestClientFeature
GO

-- Drop no longer exisiting table
DROP TABLE IWA_RestClient
GO

-- Create new added tables
CREATE TABLE IWA_RestServiceClient
(
  RestClientId BIGINT NOT NULL,
  ParentRestClientId BIGINT NULL,
  UUID VARCHAR(36) NOT NULL,
  ApplicationId BIGINT NOT NULL,
  EnvironmentId BIGINT NULL,
  Name VARCHAR(200) NOT NULL,
  Description VARCHAR(2000) NOT NULL,
  URI VARCHAR(1024) NULL,
  PRIMARY KEY (RestClientId),
  UNIQUE (ApplicationId, ParentRestClientId, EnvironmentId, UUID),
  UNIQUE (ApplicationId, ParentRestClientId, EnvironmentId, Name)
)
GO

CREATE TABLE IWA_RestServiceClientProperty
(
  RestClientPropertyId BIGINT NOT NULL,
  RestClientId BIGINT NOT NULL,
  Name VARCHAR(200) NOT NULL,
  "Value" VARCHAR(1024) NOT NULL,
  IsPassword BIT NOT NULL,
  PRIMARY KEY (RestClientPropertyId)
)
GO

CREATE TABLE IWA_RestServiceClientFeature
(
  RestClientFeatureId BIGINT NOT NULL,
  RestClientId BIGINT NOT NULL,
  Class VARCHAR(200) NOT NULL,
  PRIMARY KEY (RestClientFeatureId)
)
GO


-- Create trigger which depend on new added table
CREATE TRIGGER IWA_RestServiceClientDeleteTrigger
  ON IWA_RestServiceClient FOR DELETE AS
  IF (@@ROWCOUNT > 0)
  BEGIN

    DELETE IWA_RestServiceClient FROM IWA_RestServiceClient, deleted
    WHERE IWA_RestServiceClient.ParentRestClientId = deleted.RestClientId

    DELETE IWA_RestServiceClientProperty FROM IWA_RestServiceClientProperty, deleted
    WHERE IWA_RestServiceClientProperty.RestClientId = deleted.RestClientId

    DELETE IWA_RestServiceClientFeature FROM IWA_RestServiceClientFeature, deleted
    WHERE IWA_RestServiceClientFeature.RestClientId = deleted.RestClientId

    END
GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ApplicationDeleteTrigger
  ON IWA_Application FOR DELETE AS

  DELETE IWA_ApplicationProperty FROM IWA_ApplicationProperty, deleted
  WHERE IWA_ApplicationProperty.ApplicationId = deleted.ApplicationId

  DELETE IWA_Environment FROM IWA_Environment, deleted
  WHERE IWA_Environment.ApplicationId = deleted.ApplicationId

  DELETE IWA_GlobalVariable FROM IWA_GlobalVariable, deleted
  WHERE IWA_GlobalVariable.ApplicationId = deleted.ApplicationId

  DELETE IWA_WebService FROM IWA_WebService, deleted
  WHERE IWA_WebService.ApplicationId = deleted.ApplicationId

  DELETE IWA_ExternalNamingAndDirectory FROM IWA_ExternalNamingAndDirectory, deleted
  WHERE IWA_ExternalNamingAndDirectory.ApplicationId = deleted.ApplicationId

  DELETE IWA_ExternalDatabase FROM IWA_ExternalDatabase, deleted
  WHERE IWA_ExternalDatabase.ApplicationId = deleted.ApplicationId

  DELETE IWA_ProcessModel FROM IWA_ProcessModel, deleted
  WHERE IWA_ProcessModel.ApplicationId = deleted.ApplicationId

  DELETE IWA_Role FROM IWA_Role, deleted
  WHERE IWA_Role.ApplicationId = deleted.ApplicationId

  DELETE IWA_User FROM IWA_User, deleted
  WHERE IWA_User.ApplicationId = deleted.ApplicationId

  DELETE IWA_SignalEvent FROM IWA_SignalEvent, deleted
  WHERE IWA_SignalEvent.ApplicationId = deleted.ApplicationId

  DELETE IWA_ContentManagementSystem FROM IWA_ContentManagementSystem, deleted
  WHERE IWA_ContentManagementSystem.ApplicationId = deleted.ApplicationId

  DELETE IWA_RestServiceClient FROM IWA_RestServiceClient, deleted
  WHERE IWA_RestServiceClient.ApplicationId = deleted.ApplicationId

  DELETE IWA_SecurityDescriptor FROM IWA_SecurityDescriptor, deleted
  WHERE IWA_SecurityDescriptor.SecurityDescriptorId = deleted.SecurityDescriptorId


GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_EnvironmentDeleteTrigger
  ON IWA_Environment FOR DELETE AS

  DELETE IWA_GlobalVariable FROM IWA_GlobalVariable, deleted
  WHERE IWA_GlobalVariable.EnvironmentId = deleted.EnvironmentId

  DELETE IWA_WebServiceEnvironment FROM IWA_WebServiceEnvironment, deleted
  WHERE IWA_WebServiceEnvironment.EnvironmentId = deleted.EnvironmentId

  DELETE IWA_ExternalDatabase FROM IWA_ExternalDatabase, deleted
  WHERE IWA_ExternalDatabase.EnvironmentId = deleted.EnvironmentId

  UPDATE IWA_Case  SET IWA_Case.EnvironmentId=NULL
  FROM IWA_Case, deleted
  WHERE IWA_Case.EnvironmentId = deleted.EnvironmentId

  DELETE IWA_RestServiceClient FROM IWA_RestServiceClient, deleted
  WHERE IWA_RestServiceClient.EnvironmentId = deleted.EnvironmentId


GO

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0
GO

COMMIT TRANSACTION
GO

-- 
-- Alter database so that recursive triggers work.
-- 
ALTER DATABASE [${databaseName}] SET RECURSIVE_TRIGGERS ON
GO


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=39
GO
