-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 46 to version 47
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Microsoft SQL Server
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------


-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_WebServiceEnvironmentDeleteTrigger
GO

-- Create new added tables
CREATE TABLE IWA_WebServiceFeature
(
  WebServiceFeatureId BIGINT NOT NULL,
  WebServiceEnvironmentId BIGINT NOT NULL,
  Class VARCHAR(200) NOT NULL,
  PRIMARY KEY (WebServiceFeatureId)
)
GO

CREATE TABLE IWA_WebServiceProperty
(
  WebServicePropertyId BIGINT NOT NULL,
  WebServiceEnvironmentId BIGINT NOT NULL,
  Name VARCHAR(200) NOT NULL,
  "Value" VARCHAR(1024) NOT NULL,
  IsPassword BIT NOT NULL,
  PRIMARY KEY (WebServicePropertyId)
)
GO


-- Drop unique constraint which depend on changed columns or was deleted
-- Store Procedure to drop a unique constraint
CREATE PROCEDURE IWA_Drop_Unique
@tablename varchar(100)
AS
DECLARE @parentid integer
DECLARE @uqname varchar(100)
DECLARE table_cursor CURSOR FOR SELECT id FROM sysobjects WHERE name = @tablename
OPEN  table_cursor
FETCH NEXT FROM table_cursor INTO @parentid
IF @@FETCH_STATUS<>0
BEGIN
  RAISERROR ('TABLE %s not found in table sysobjects', 16, 1, @tablename)
  CLOSE table_cursor
  DEALLOCATE table_cursor
  RETURN
END
DECLARE uq_cursor CURSOR FOR
SELECT name from sysobjects WHERE parent_obj = @parentid AND xtype = 'UQ'
CLOSE table_cursor
DEALLOCATE table_cursor
OPEN uq_cursor
FETCH NEXT FROM uq_cursor INTO @uqname
IF @@FETCH_STATUS<>0
BEGIN
  RAISERROR('Unique constraint of table %s not found in table sysobjects', 16, 1, @tablename);
  CLOSE uq_cursor
  DEALLOCATE uq_cursor
  RETURN
END
WHILE @@FETCH_STATUS=0
BEGIN
  EXEC('ALTER TABLE '+@tablename+' DROP CONSTRAINT '+@uqname)
  FETCH NEXT FROM uq_cursor INTO @uqname
END
CLOSE uq_cursor
DEALLOCATE uq_cursor
GO

EXECUTE IWA_Drop_Unique 'IWA_WebService'
GO

-- Dropped columns of table IWA_WebService
ALTER TABLE IWA_WebService DROP COLUMN Tag
GO

ALTER TABLE IWA_WebService DROP COLUMN GenerationPropertiesVersion
GO

ALTER TABLE IWA_WebService DROP COLUMN GenerationProperties
GO


-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_WebService ADD UNIQUE (ApplicationId, GenerationIdentifier)
GO

-- Create new triggers on existing table(s)
CREATE TRIGGER IWA_PermissionDeleteTrigger
  ON IWA_Permission FOR DELETE AS

  DELETE IWA_PermissionGroupPermission FROM IWA_PermissionGroupPermission, deleted
  WHERE IWA_PermissionGroupPermission.PermissionId = deleted.PermissionId


GO


-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_WebServiceEnvironmentDeleteTrigger
  ON IWA_WebServiceEnvironment FOR DELETE AS

  DELETE IWA_WebServiceFeature FROM IWA_WebServiceFeature, deleted
  WHERE IWA_WebServiceFeature.WebServiceEnvironmentId = deleted.WebServiceEnvironmentId

  DELETE IWA_WebServiceProperty FROM IWA_WebServiceProperty, deleted
  WHERE IWA_WebServiceProperty.WebServiceEnvironmentId = deleted.WebServiceEnvironmentId

  DELETE IWA_WebServiceEndpoint FROM IWA_WebServiceEndpoint, deleted
  WHERE IWA_WebServiceEndpoint.WebServiceEnvironmentId = deleted.WebServiceEnvironmentId


GO

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0
GO

-- Drop temporary created stored procedures needed for conversion
DROP PROCEDURE IWA_Drop_Unique
GO

-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=47
GO
