-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 50 to version 51
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Microsoft SQL Server
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------


-- Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_UserDeleteTrigger
GO

-- Drop no longer exisiting table
DROP TABLE IWA_RichDialogUserContext
GO

-- Create new added tables
CREATE TABLE IWA_TaskCustomStringField
(
  TaskCustomStringFieldId BIGINT NOT NULL,
  TaskId BIGINT NOT NULL REFERENCES IWA_Task(TaskId) ON DELETE CASCADE,
  Name VARCHAR(200) NOT NULL,
  "Value" VARCHAR(2000) NOT NULL,
  PRIMARY KEY (TaskCustomStringFieldId),
  UNIQUE (TaskId, Name)
)
GO

CREATE INDEX IWA_TaskCstmStringFldValueIdx
ON IWA_TaskCustomStringField ("Value")
GO

CREATE TABLE IWA_TaskCustomTextField
(
  TaskCustomTextFieldId BIGINT NOT NULL,
  TaskId BIGINT NOT NULL REFERENCES IWA_Task(TaskId) ON DELETE CASCADE,
  Name VARCHAR(200) NOT NULL,
  "Value" VARCHAR(MAX) NOT NULL,
  PRIMARY KEY (TaskCustomTextFieldId),
  UNIQUE (TaskId, Name)
)
GO

CREATE TABLE IWA_TaskCustomNumberField
(
  TaskCustomNumberFieldId BIGINT NOT NULL,
  TaskId BIGINT NOT NULL REFERENCES IWA_Task(TaskId) ON DELETE CASCADE,
  Name VARCHAR(200) NOT NULL,
  "Value" DECIMAL(30, 10) NOT NULL,
  PRIMARY KEY (TaskCustomNumberFieldId),
  UNIQUE (TaskId, Name)
)
GO

CREATE INDEX IWA_TaskCstmNumberFldValueIdx
ON IWA_TaskCustomNumberField ("Value")
GO

CREATE TABLE IWA_TaskCustomTimestampField
(
  TaskCustomTimestampFieldId BIGINT NOT NULL,
  TaskId BIGINT NOT NULL REFERENCES IWA_Task(TaskId) ON DELETE CASCADE,
  Name VARCHAR(200) NOT NULL,
  "Value" DATETIME NOT NULL,
  PRIMARY KEY (TaskCustomTimestampFieldId),
  UNIQUE (TaskId, Name)
)
GO

CREATE INDEX IWA_TaskCstmTmstmpFldValIdx
ON IWA_TaskCustomTimestampField ("Value")
GO

CREATE TABLE IWA_CaseCustomStringField
(
  CaseCustomStringFieldId BIGINT NOT NULL,
  CaseId BIGINT NOT NULL REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  Name VARCHAR(200) NOT NULL,
  "Value" VARCHAR(2000) NOT NULL,
  PRIMARY KEY (CaseCustomStringFieldId),
  UNIQUE (CaseId, Name)
)
GO

CREATE INDEX IWA_CaseCstmStringFldValueIdx
ON IWA_CaseCustomStringField ("Value")
GO

CREATE TABLE IWA_CaseCustomTextField
(
  CaseCustomTextFieldId BIGINT NOT NULL,
  CaseId BIGINT NOT NULL REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  Name VARCHAR(200) NOT NULL,
  "Value" VARCHAR(MAX) NOT NULL,
  PRIMARY KEY (CaseCustomTextFieldId),
  UNIQUE (CaseId, Name)
)
GO

CREATE TABLE IWA_CaseCustomNumberField
(
  CaseCustomNumberFieldId BIGINT NOT NULL,
  CaseId BIGINT NOT NULL REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  Name VARCHAR(200) NOT NULL,
  "Value" DECIMAL(30, 10) NOT NULL,
  PRIMARY KEY (CaseCustomNumberFieldId),
  UNIQUE (CaseId, Name)
)
GO

CREATE INDEX IWA_CaseCstmNubmerFldValueIdx
ON IWA_CaseCustomNumberField ("Value")
GO

CREATE TABLE IWA_CaseCustomTimestampField
(
  CaseCustomTimestampFieldId BIGINT NOT NULL,
  CaseId BIGINT NOT NULL REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  Name VARCHAR(200) NOT NULL,
  "Value" DATETIME NOT NULL,
  PRIMARY KEY (CaseCustomTimestampFieldId),
  UNIQUE (CaseId, Name)
)
GO

CREATE INDEX IWA_CaseCstmTmstmpFldValIdx
ON IWA_CaseCustomTimestampField ("Value")
GO


-- Drop unique constraint which depend on changed columns or was deleted
-- Store Procedure to drop a unique constraint
CREATE PROCEDURE IWA_Drop_Unique
@tablename varchar(100)
AS
DECLARE @parentid integer
DECLARE @uqname varchar(100)
DECLARE table_cursor CURSOR FOR SELECT id FROM sysobjects WHERE name = @tablename
OPEN  table_cursor
FETCH NEXT FROM table_cursor INTO @parentid
IF @@FETCH_STATUS<>0
BEGIN
  RAISERROR ('TABLE %s not found in table sysobjects', 16, 1, @tablename)
  CLOSE table_cursor
  DEALLOCATE table_cursor
  RETURN
END
DECLARE uq_cursor CURSOR FOR
SELECT name from sysobjects WHERE parent_obj = @parentid AND xtype = 'UQ'
CLOSE table_cursor
DEALLOCATE table_cursor
OPEN uq_cursor
FETCH NEXT FROM uq_cursor INTO @uqname
IF @@FETCH_STATUS<>0
BEGIN
  RAISERROR('Unique constraint of table %s not found in table sysobjects', 16, 1, @tablename);
  CLOSE uq_cursor
  DEALLOCATE uq_cursor
  RETURN
END
WHILE @@FETCH_STATUS=0
BEGIN
  EXEC('ALTER TABLE '+@tablename+' DROP CONSTRAINT '+@uqname)
  FETCH NEXT FROM uq_cursor INTO @uqname
END
CLOSE uq_cursor
DEALLOCATE uq_cursor
GO

EXECUTE IWA_Drop_Unique 'IWA_UserSubstitute'
GO

-- Added columns of table IWA_UserSubstitute
ALTER TABLE IWA_UserSubstitute ADD
  SubstitutionType INTEGER NOT NULL DEFAULT 0
GO

-- Create unique constraints which depend on changed columns
ALTER TABLE IWA_UserSubstitute ADD UNIQUE (UserId, SubstituteUserId, SubstituteForRoleId)
GO

-- Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_UserDeleteTrigger
  ON IWA_User FOR DELETE AS

  UPDATE IWA_Task  SET IWA_Task.State=9, IWA_Task.FailedTimeoutTimestamp=NULL, IWA_Task.WorkerUserId=NULL, IWA_Task.WorkerUserName=NULL
  FROM IWA_Task, deleted
  WHERE ((IWA_Task.ActivatorUserId = deleted.UserId AND IWA_Task.IsExpired = 0) OR (IWA_Task.ExpiryActivatorUserId = deleted.UserId AND IWA_Task.IsExpired = 1)) AND (IWA_Task."State" = 3 OR IWA_Task."State" = 4 OR IWA_Task."State" = 8 OR IWA_Task."State" = 10)

  UPDATE IWA_Task  SET IWA_Task.State=4, IWA_Task.WorkerUserName=NULL
  FROM IWA_Task, deleted
  WHERE IWA_Task.WorkerUserId = deleted.UserId AND IWA_Task."State" = 8

  DELETE IWA_UserRole FROM IWA_UserRole, deleted
  WHERE IWA_UserRole.UserId = deleted.UserId

  DELETE IWA_UserProperty FROM IWA_UserProperty, deleted
  WHERE IWA_UserProperty.UserId = deleted.UserId

  DELETE IWA_UserAbsence FROM IWA_UserAbsence, deleted
  WHERE IWA_UserAbsence.UserId = deleted.UserId

  DELETE IWA_UserSubstitute FROM IWA_UserSubstitute, deleted
  WHERE IWA_UserSubstitute.UserId = deleted.UserId

  DELETE IWA_UserSubstitute FROM IWA_UserSubstitute, deleted
  WHERE IWA_UserSubstitute.SubstituteUserId = deleted.UserId

  UPDATE IWA_StartElement  SET IWA_StartElement.ActivatorUserId=NULL
  FROM IWA_StartElement, deleted
  WHERE IWA_StartElement.ActivatorUserId = deleted.UserId

  UPDATE IWA_Case  SET IWA_Case.CreatorUserId=NULL
  FROM IWA_Case, deleted
  WHERE IWA_Case.CreatorUserId = deleted.UserId

  UPDATE IWA_Case  SET IWA_Case.OwnerUserId=NULL
  FROM IWA_Case, deleted
  WHERE IWA_Case.OwnerUserId = deleted.UserId

  UPDATE IWA_Task  SET IWA_Task.WorkerUserId=NULL
  FROM IWA_Task, deleted
  WHERE IWA_Task.WorkerUserId = deleted.UserId

  UPDATE IWA_Task  SET IWA_Task.ActivatorUserId=NULL
  FROM IWA_Task, deleted
  WHERE IWA_Task.ActivatorUserId = deleted.UserId

  UPDATE IWA_Task  SET IWA_Task.ExpiryActivatorUserId=NULL
  FROM IWA_Task, deleted
  WHERE IWA_Task.ExpiryActivatorUserId = deleted.UserId

  UPDATE IWA_WorkflowEvent  SET IWA_WorkflowEvent.UserId=NULL
  FROM IWA_WorkflowEvent, deleted
  WHERE IWA_WorkflowEvent.UserId = deleted.UserId

  UPDATE IWA_Note  SET IWA_Note.UserId=NULL
  FROM IWA_Note, deleted
  WHERE IWA_Note.UserId = deleted.UserId

  DELETE IWA_UserLocation FROM IWA_UserLocation, deleted
  WHERE IWA_UserLocation.UserId = deleted.UserId

  UPDATE IWA_SignalEvent  SET IWA_SignalEvent.SentByUserId=NULL
  FROM IWA_SignalEvent, deleted
  WHERE IWA_SignalEvent.SentByUserId = deleted.UserId

  UPDATE IWA_PageArchive  SET IWA_PageArchive.UserId=NULL
  FROM IWA_PageArchive, deleted
  WHERE IWA_PageArchive.UserId = deleted.UserId

  UPDATE IWA_SecurityDescriptor  SET IWA_SecurityDescriptor.OwnerUserId=NULL
  FROM IWA_SecurityDescriptor, deleted
  WHERE IWA_SecurityDescriptor.OwnerUserId = deleted.UserId

  DELETE IWA_AccessControl FROM IWA_AccessControl, deleted
  WHERE IWA_AccessControl.UserId = deleted.UserId


GO


-- Create added views
CREATE VIEW IWA_TaskCustomField
(
  TaskId,
  Name,
  "Type",
  StringValue,
  TextValue,
  NumberValue,
  TimestampValue
)
AS
  SELECT
    StringField.TaskId,
    StringField.Name,
    'String',
    StringField."Value",
    NULL,
    NULL,
    NULL
  FROM IWA_TaskCustomStringField AS StringField
UNION ALL
  SELECT
    TextField.TaskId,
    TextField.Name,
    'Text',
    NULL,
    TextField."Value",
    NULL,
    NULL
  FROM IWA_TaskCustomTextField AS TextField
UNION ALL
  SELECT
    NumberField.TaskId,
    NumberField.Name,
    'Number',
    NULL,
    NULL,
    NumberField."Value",
    NULL
  FROM IWA_TaskCustomNumberField AS NumberField
UNION ALL
  SELECT
    TimestampField.TaskId,
    TimestampField.Name,
    'Timestamp',
    NULL,
    NULL,
    NULL,
    TimestampField."Value"
  FROM IWA_TaskCustomTimestampField AS TimestampField
GO

CREATE VIEW IWA_CaseCustomField
(
  CaseId,
  Name,
  "Type",
  StringValue,
  TextValue,
  NumberValue,
  TimestampValue
)
AS
  SELECT
    StringField.CaseId,
    StringField.Name,
    'String',
    StringField."Value",
    NULL,
    NULL,
    NULL
  FROM IWA_CaseCustomStringField AS StringField
UNION ALL
  SELECT
    TextField.CaseId,
    TextField.Name,
    'Text',
    NULL,
    TextField."Value",
    NULL,
    NULL
  FROM IWA_CaseCustomTextField AS TextField
UNION ALL
  SELECT
    NumberField.CaseId,
    NumberField.Name,
    'Number',
    NULL,
    NULL,
    NumberField."Value",
    NULL
  FROM IWA_CaseCustomNumberField AS NumberField
UNION ALL
  SELECT
    TimestampField.CaseId,
    TimestampField.Name,
    'Timestamp',
    NULL,
    NULL,
    NULL,
    TimestampField."Value"
  FROM IWA_CaseCustomTimestampField AS TimestampField
GO

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0
GO

-- Drop temporary created stored procedures needed for conversion
DROP PROCEDURE IWA_Drop_Unique
GO

-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=51
GO
