-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 51 to version 52
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Microsoft SQL Server
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------


-- Drop removed indexes of table IWA_TaskCustomStringField
DROP INDEX IWA_TaskCustomStringField.IWA_TaskCstmStringFldValueIdx
GO

-- Drop removed indexes of table IWA_TaskCustomNumberField
DROP INDEX IWA_TaskCustomNumberField.IWA_TaskCstmNumberFldValueIdx
GO

-- Drop removed indexes of table IWA_TaskCustomTimestampField
DROP INDEX IWA_TaskCustomTimestampField.IWA_TaskCstmTmstmpFldValIdx
GO

-- Drop removed indexes of table IWA_CaseCustomStringField
DROP INDEX IWA_CaseCustomStringField.IWA_CaseCstmStringFldValueIdx
GO

-- Drop removed indexes of table IWA_CaseCustomNumberField
DROP INDEX IWA_CaseCustomNumberField.IWA_CaseCstmNubmerFldValueIdx
GO

-- Drop removed indexes of table IWA_CaseCustomTimestampField
DROP INDEX IWA_CaseCustomTimestampField.IWA_CaseCstmTmstmpFldValIdx
GO

-- Remove duplicated task additional properties
DELETE FROM IWA_TaskAdditionalProperty 
WHERE AdditionalPropertyId NOT IN (
	SELECT MAX(TAP.AdditionalPropertyId) 
	FROM IWA_TaskAdditionalProperty AS TAP 
	INNER JOIN IWA_AdditionalProperty AS AP ON TAP.AdditionalPropertyId = AP.AdditionalPropertyId 
	GROUP BY TAP.TaskId, AP.Name
)
GO

-- Migrate task additional properties to task custom text fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(TaskCustomTextFieldId), 0) FROM IWA_TaskCustomTextField)

INSERT INTO IWA_TaskCustomTextField (TaskCustomTextFieldId, TaskId, Name, "Value")
SELECT
  @MAX_ID + 1 + IWA_AdditionalProperty.AdditionalPropertyId,
  IWA_TaskAdditionalProperty.TaskId,
  IWA_AdditionalProperty.Name,
  IWA_AdditionalProperty."Value"
FROM IWA_TaskAdditionalProperty
    INNER JOIN IWA_AdditionalProperty ON IWA_TaskAdditionalProperty.AdditionalPropertyId = IWA_AdditionalProperty.AdditionalPropertyId
    INNER JOIN IWA_Task ON IWA_TaskAdditionalProperty.TaskId = IWA_Task.TaskId
GO

-- Migrate column CustomVarCharField1 of task to task custom string fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(TaskCustomStringFieldId), 0) FROM IWA_TaskCustomStringField)

INSERT INTO IWA_TaskCustomStringField (TaskCustomStringFieldId, TaskId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + TaskId,
  TaskId,
  'CustomVarCharField1',
  CustomVarCharField1
FROM IWA_Task
WHERE CustomVarCharField1 IS NOT NULL
GO

-- Migrate column CustomVarCharField2 of task to task custom string fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(TaskCustomStringFieldId), 0) FROM IWA_TaskCustomStringField)

INSERT INTO IWA_TaskCustomStringField (TaskCustomStringFieldId, TaskId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + TaskId,
  TaskId,
  'CustomVarCharField2',
  CustomVarCharField2
FROM IWA_Task
WHERE CustomVarCharField2 IS NOT NULL
GO

-- Migrate column CustomVarCharField3 of task to task custom string fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(TaskCustomStringFieldId), 0) FROM IWA_TaskCustomStringField)

INSERT INTO IWA_TaskCustomStringField (TaskCustomStringFieldId, TaskId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + TaskId,
  TaskId,
  'CustomVarCharField3',
  CustomVarCharField3
FROM IWA_Task
WHERE CustomVarCharField3 IS NOT NULL
GO

-- Migrate column CustomVarCharField4 of task to task custom string fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(TaskCustomStringFieldId), 0) FROM IWA_TaskCustomStringField)

INSERT INTO IWA_TaskCustomStringField (TaskCustomStringFieldId, TaskId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + TaskId,
  TaskId,
  'CustomVarCharField4',
  CustomVarCharField4
FROM IWA_Task
WHERE CustomVarCharField4 IS NOT NULL
GO

-- Migrate column CustomVarCharField5 of task to task custom string fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(TaskCustomStringFieldId), 0) FROM IWA_TaskCustomStringField)

INSERT INTO IWA_TaskCustomStringField (TaskCustomStringFieldId, TaskId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + TaskId,
  TaskId,
  'CustomVarCharField5',
  CustomVarCharField5
FROM IWA_Task
WHERE CustomVarCharField5 IS NOT NULL
GO

-- Migrate column CustomDecimalField1 of task to task custom number fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(TaskCustomNumberFieldId), 0) FROM IWA_TaskCustomNumberField)

INSERT INTO IWA_TaskCustomNumberField (TaskCustomNumberFieldId, TaskId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + TaskId,
  TaskId,
  'CustomDecimalField1',
  CustomDecimalField1
FROM IWA_Task
WHERE CustomDecimalField1 IS NOT NULL
GO

-- Migrate column CustomDecimalField2 of task to task custom number fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(TaskCustomNumberFieldId), 0) FROM IWA_TaskCustomNumberField)

INSERT INTO IWA_TaskCustomNumberField (TaskCustomNumberFieldId, TaskId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + TaskId,
  TaskId,
  'CustomDecimalField2',
  CustomDecimalField2
FROM IWA_Task
WHERE CustomDecimalField2 IS NOT NULL
GO

-- Migrate column CustomDecimalField3 of task to task custom number fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(TaskCustomNumberFieldId), 0) FROM IWA_TaskCustomNumberField)

INSERT INTO IWA_TaskCustomNumberField (TaskCustomNumberFieldId, TaskId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + TaskId,
  TaskId,
  'CustomDecimalField3',
  CustomDecimalField3
FROM IWA_Task
WHERE CustomDecimalField3 IS NOT NULL
GO

-- Migrate column CustomDecimalField4 of task to task custom number fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(TaskCustomNumberFieldId), 0) FROM IWA_TaskCustomNumberField)

INSERT INTO IWA_TaskCustomNumberField (TaskCustomNumberFieldId, TaskId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + TaskId,
  TaskId,
  'CustomDecimalField4',
  CustomDecimalField4
FROM IWA_Task
WHERE CustomDecimalField4 IS NOT NULL
GO

-- Migrate column CustomDecimalField5 of task to task custom number fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(TaskCustomNumberFieldId), 0) FROM IWA_TaskCustomNumberField)

INSERT INTO IWA_TaskCustomNumberField (TaskCustomNumberFieldId, TaskId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + TaskId,
  TaskId,
  'CustomDecimalField5',
  CustomDecimalField5
FROM IWA_Task
WHERE CustomDecimalField5 IS NOT NULL
GO

-- Migrate column CustomTimestampField1 of task to task custom timestamp fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(TaskCustomTimestampFieldId), 0) FROM IWA_TaskCustomTimestampField)

INSERT INTO IWA_TaskCustomTimestampField (TaskCustomTimestampFieldId, TaskId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + TaskId,
  TaskId,
  'CustomTimestampField1',
  CustomTimestampField1
FROM IWA_Task
WHERE CustomTimestampField1 IS NOT NULL
GO

-- Migrate column CustomTimestampField2 of task to task custom timestamp fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(TaskCustomTimestampFieldId), 0) FROM IWA_TaskCustomTimestampField)

INSERT INTO IWA_TaskCustomTimestampField (TaskCustomTimestampFieldId, TaskId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + TaskId,
  TaskId,
  'CustomTimestampField2',
  CustomTimestampField2
FROM IWA_Task
WHERE CustomTimestampField2 IS NOT NULL
GO

-- Migrate column CustomTimestampField3 of task to task custom timestamp fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(TaskCustomTimestampFieldId), 0) FROM IWA_TaskCustomTimestampField)

INSERT INTO IWA_TaskCustomTimestampField (TaskCustomTimestampFieldId, TaskId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + TaskId,
  TaskId,
  'CustomTimestampField3',
  CustomTimestampField3
FROM IWA_Task
WHERE CustomTimestampField3 IS NOT NULL
GO

-- Migrate column CustomTimestampField4 of task to task custom timestamp fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(TaskCustomTimestampFieldId), 0) FROM IWA_TaskCustomTimestampField)

INSERT INTO IWA_TaskCustomTimestampField (TaskCustomTimestampFieldId, TaskId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + TaskId,
  TaskId,
  'CustomTimestampField4',
  CustomTimestampField4
FROM IWA_Task
WHERE CustomTimestampField4 IS NOT NULL
GO

-- Migrate column CustomTimestampField5 of task to task custom timestamp fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(TaskCustomTimestampFieldId), 0) FROM IWA_TaskCustomTimestampField)

INSERT INTO IWA_TaskCustomTimestampField (TaskCustomTimestampFieldId, TaskId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + TaskId,
  TaskId,
  'CustomTimestampField5',
  CustomTimestampField5
FROM IWA_Task
WHERE CustomTimestampField5 IS NOT NULL
GO


-- Remove duplicated case additional properties
DELETE FROM IWA_CaseAdditionalProperty 
WHERE AdditionalPropertyId NOT IN (
	SELECT MAX(CAP.AdditionalPropertyId) 
	FROM IWA_CaseAdditionalProperty AS CAP 
	INNER JOIN IWA_AdditionalProperty AS AP ON CAP.AdditionalPropertyId = AP.AdditionalPropertyId 
	GROUP BY CAP.CaseId, AP.Name
)
GO

-- Migrate case additional properties to case custom text fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomTextFieldId), 0) FROM IWA_CaseCustomTextField)

INSERT INTO IWA_CaseCustomTextField (CaseCustomTextFieldId, CaseId, Name, "Value")
SELECT
  @MAX_ID + 1 + IWA_AdditionalProperty.AdditionalPropertyId,
  IWA_CaseAdditionalProperty.CaseId,
  IWA_AdditionalProperty.Name,
  IWA_AdditionalProperty."Value"
FROM IWA_CaseAdditionalProperty
    INNER JOIN IWA_AdditionalProperty ON IWA_CaseAdditionalProperty.AdditionalPropertyId = IWA_AdditionalProperty.AdditionalPropertyId
    INNER JOIN IWA_Case ON IWA_CaseAdditionalProperty.CaseId = IWA_Case.CaseId
GO

-- Migrate column CustomVarCharField1 of case to case custom string fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomStringFieldId), 0) FROM IWA_CaseCustomStringField)

INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'CustomVarCharField1',
  CustomVarCharField1
FROM IWA_Case
WHERE CustomVarCharField1 IS NOT NULL
GO

-- Migrate column CustomVarCharField2 of case to case custom string fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomStringFieldId), 0) FROM IWA_CaseCustomStringField)

INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'CustomVarCharField2',
  CustomVarCharField2
FROM IWA_Case
WHERE CustomVarCharField2 IS NOT NULL
GO

-- Migrate column CustomVarCharField3 of case to case custom string fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomStringFieldId), 0) FROM IWA_CaseCustomStringField)

INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'CustomVarCharField3',
  CustomVarCharField3
FROM IWA_Case
WHERE CustomVarCharField3 IS NOT NULL
GO

-- Migrate column CustomVarCharField4 of case to case custom string fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomStringFieldId), 0) FROM IWA_CaseCustomStringField)

INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'CustomVarCharField4',
  CustomVarCharField4
FROM IWA_Case
WHERE CustomVarCharField4 IS NOT NULL
GO

-- Migrate column CustomVarCharField5 of case to case custom string fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomStringFieldId), 0) FROM IWA_CaseCustomStringField)

INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'CustomVarCharField5',
  CustomVarCharField5
FROM IWA_Case
WHERE CustomVarCharField5 IS NOT NULL
GO

-- Migrate column CustomDecimalField1 of case to case custom number fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomNumberFieldId), 0) FROM IWA_CaseCustomNumberField)

INSERT INTO IWA_CaseCustomNumberField (CaseCustomNumberFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'CustomDecimalField1',
  CustomDecimalField1
FROM IWA_Case
WHERE CustomDecimalField1 IS NOT NULL
GO

-- Migrate column CustomDecimalField2 of case to case custom number fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomNumberFieldId), 0) FROM IWA_CaseCustomNumberField)

INSERT INTO IWA_CaseCustomNumberField (CaseCustomNumberFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'CustomDecimalField2',
  CustomDecimalField2
FROM IWA_Case
WHERE CustomDecimalField2 IS NOT NULL
GO

-- Migrate column CustomDecimalField3 of case to case custom number fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomNumberFieldId), 0) FROM IWA_CaseCustomNumberField)

INSERT INTO IWA_CaseCustomNumberField (CaseCustomNumberFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'CustomDecimalField3',
  CustomDecimalField3
FROM IWA_Case
WHERE CustomDecimalField3 IS NOT NULL
GO

-- Migrate column CustomDecimalField4 of case to case custom number fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomNumberFieldId), 0) FROM IWA_CaseCustomNumberField)

INSERT INTO IWA_CaseCustomNumberField (CaseCustomNumberFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'CustomDecimalField4',
  CustomDecimalField4
FROM IWA_Case
WHERE CustomDecimalField4 IS NOT NULL
GO

-- Migrate column CustomDecimalField5 of case to case custom number fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomNumberFieldId), 0) FROM IWA_CaseCustomNumberField)

INSERT INTO IWA_CaseCustomNumberField (CaseCustomNumberFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'CustomDecimalField5',
  CustomDecimalField5
FROM IWA_Case
WHERE CustomDecimalField5 IS NOT NULL
GO

-- Migrate column CustomTimestampField1 of case to case custom timestamp fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomTimestampFieldId), 0) FROM IWA_CaseCustomTimestampField)

INSERT INTO IWA_CaseCustomTimestampField (CaseCustomTimestampFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'CustomTimestampField1',
  CustomTimestampField1
FROM IWA_Case
WHERE CustomTimestampField1 IS NOT NULL
GO

-- Migrate column CustomTimestampField2 of case to case custom timestamp fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomTimestampFieldId), 0) FROM IWA_CaseCustomTimestampField)

INSERT INTO IWA_CaseCustomTimestampField (CaseCustomTimestampFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'CustomTimestampField2',
  CustomTimestampField2
FROM IWA_Case
WHERE CustomTimestampField2 IS NOT NULL
GO

-- Migrate column CustomTimestampField3 of case to case custom timestamp fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomTimestampFieldId), 0) FROM IWA_CaseCustomTimestampField)

INSERT INTO IWA_CaseCustomTimestampField (CaseCustomTimestampFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'CustomTimestampField3',
  CustomTimestampField3
FROM IWA_Case
WHERE CustomTimestampField3 IS NOT NULL
GO

-- Migrate column CustomTimestampField4 of case to case custom timestamp fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomTimestampFieldId), 0) FROM IWA_CaseCustomTimestampField)

INSERT INTO IWA_CaseCustomTimestampField (CaseCustomTimestampFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'CustomTimestampField4',
  CustomTimestampField4
FROM IWA_Case
WHERE CustomTimestampField4 IS NOT NULL
GO

-- Migrate column CustomTimestampField5 of case to case custom timestamp fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomTimestampFieldId), 0) FROM IWA_CaseCustomTimestampField)

INSERT INTO IWA_CaseCustomTimestampField (CaseCustomTimestampFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'CustomTimestampField5',
  CustomTimestampField5
FROM IWA_Case
WHERE CustomTimestampField5 IS NOT NULL
GO


-- Create new indexes of table IWA_TaskCustomStringField
CREATE INDEX IWA_TaskCstmStringFldNmValIdx
ON IWA_TaskCustomStringField (Name, "Value")
GO


-- Create new indexes of table IWA_TaskCustomTextField
CREATE INDEX IWA_TaskCstmTextFldNameIdx
ON IWA_TaskCustomTextField (Name)
GO


-- Create new indexes of table IWA_TaskCustomNumberField
CREATE INDEX IWA_TaskCstmNumberFldNmValIdx
ON IWA_TaskCustomNumberField (Name, "Value")
GO


-- Create new indexes of table IWA_TaskCustomTimestampField
CREATE INDEX IWA_TaskCstmTmstmpFldNmValIdx
ON IWA_TaskCustomTimestampField (Name, "Value")
GO


-- Create new indexes of table IWA_CaseCustomStringField
CREATE INDEX IWA_CaseCstmStringFldNmValIdx
ON IWA_CaseCustomStringField (Name, "Value")
GO


-- Create new indexes of table IWA_CaseCustomTextField
CREATE INDEX IWA_CaseCstmTextFldNameIdx
ON IWA_CaseCustomTextField (Name)
GO


-- Create new indexes of table IWA_CaseCustomNumberField
CREATE INDEX IWA_CaseCstmNumberFldNmValIdx
ON IWA_CaseCustomNumberField (Name, "Value")
GO


-- Create new indexes of table IWA_CaseCustomTimestampField
CREATE INDEX IWA_CaseCstmTmstmpFldNmValIdx
ON IWA_CaseCustomTimestampField (Name, "Value")
GO


-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0
GO


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=52
GO
