-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 56 to version 57
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Microsoft SQL Server
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------

-- Migrate column ProcessCategoryCode of case to case custom string fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomStringFieldId), 0) FROM IWA_CaseCustomStringField)

INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'ProcessCategoryCode',
  ProcessCategoryCode
FROM IWA_Case
WHERE ProcessCategoryCode IS NOT NULL
GO

-- Migrate column ProcessCategoryName of case to case custom string fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomStringFieldId), 0) FROM IWA_CaseCustomStringField)

INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'ProcessCategoryName',
  ProcessCategoryName
FROM IWA_Case
WHERE ProcessCategoryName IS NOT NULL
GO

-- Migrate column ProcessCode of case to case custom string fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomStringFieldId), 0) FROM IWA_CaseCustomStringField)

INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'ProcessCode',
  ProcessCode
FROM IWA_Case
WHERE ProcessCode IS NOT NULL
GO

-- Migrate column ProcessName of case to case custom string fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomStringFieldId), 0) FROM IWA_CaseCustomStringField)

INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'ProcessName',
  ProcessName
FROM IWA_Case
WHERE ProcessName IS NOT NULL
GO

-- Migrate column TypeCode of case to case custom string fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomStringFieldId), 0) FROM IWA_CaseCustomStringField)

INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'TypeCode',
  TypeCode
FROM IWA_Case
WHERE TypeCode IS NOT NULL
GO

-- Migrate column TypeName of case to case custom string fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomStringFieldId), 0) FROM IWA_CaseCustomStringField)

INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'TypeName',
  TypeName
FROM IWA_Case
WHERE TypeName IS NOT NULL
GO

-- Migrate column SubTypeCode of case to case custom string fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomStringFieldId), 0) FROM IWA_CaseCustomStringField)

INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'SubTypeCode',
  SubTypeCode
FROM IWA_Case
WHERE SubTypeCode IS NOT NULL
GO

-- Migrate column SubTypeName of case to case custom string fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(CaseCustomStringFieldId), 0) FROM IWA_CaseCustomStringField)

INSERT INTO IWA_CaseCustomStringField (CaseCustomStringFieldId, CaseId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + CaseId,
  CaseId,
  'SubTypeName',
  SubTypeName
FROM IWA_Case
WHERE SubTypeName IS NOT NULL
GO

-- Migrate column KindCode of task to task custom string fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(TaskCustomStringFieldId), 0) FROM IWA_TaskCustomStringField)

INSERT INTO IWA_TaskCustomStringField (TaskCustomStringFieldId, TaskId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + TaskId,
  TaskId,
  'KindCode',
  KindCode
FROM IWA_Task
WHERE KindCode IS NOT NULL
GO

-- Migrate column KindName of task to task custom string fields
DECLARE @MAX_ID BIGINT

SET @MAX_ID = (SELECT ISNULL(MAX(TaskCustomStringFieldId), 0) FROM IWA_TaskCustomStringField)

INSERT INTO IWA_TaskCustomStringField (TaskCustomStringFieldId, TaskId, Name, "VALUE")
SELECT
  @MAX_ID + 1 + TaskId,
  TaskId,
  'KindName',
  KindName
FROM IWA_Task
WHERE KindName IS NOT NULL
GO

-- Drop views which has a new definition or depend on changed tables
DROP VIEW IWA_TaskQuery
GO

DROP VIEW IWA_CaseQuery
GO


-- Drop removed indexes of table IWA_Case
DROP INDEX IWA_Case.IWA_Case_ProcessCategoryCode
GO
DROP INDEX IWA_Case.IWA_Case_ProcessCode
GO
DROP INDEX IWA_Case.IWA_Case_TypeCode
GO
DROP INDEX IWA_Case.IWA_Case_SubTypeCode
GO

-- Drop removed indexes of table IWA_Task
DROP INDEX IWA_Task.IWA_Task_KindCodeIndex
GO

-- Dropped columns of table IWA_Case
ALTER TABLE IWA_Case DROP COLUMN ProcessCategoryCode
GO

ALTER TABLE IWA_Case DROP COLUMN ProcessCategoryName
GO

ALTER TABLE IWA_Case DROP COLUMN ProcessCode
GO

ALTER TABLE IWA_Case DROP COLUMN ProcessName
GO

ALTER TABLE IWA_Case DROP COLUMN TypeCode
GO

ALTER TABLE IWA_Case DROP COLUMN TypeName
GO

ALTER TABLE IWA_Case DROP COLUMN SubTypeCode
GO

ALTER TABLE IWA_Case DROP COLUMN SubTypeName
GO


-- Dropped columns of table IWA_Task
ALTER TABLE IWA_Task DROP COLUMN KindCode
GO

ALTER TABLE IWA_Task DROP COLUMN KindName
GO


-- Recreate views which has a new definition or depend on changed tables
CREATE VIEW IWA_TaskQuery
(
  TaskId,
  CaseId,
  ProcessModelId,
  ApplicationId,
  StartTaskSwitchEventId,
  EndTaskSwitchEventId,
  TaskStartId,
  TaskEndId,
  WorkerUserId,
  WorkerUserName,
  WorkerUserDisplayName,
  WorkerSessionId,
  ActivatorRoleId,
  ActivatorUserId,
  ActivatorName,
  ActivatorDisplayName,
  ExpiryActivatorRoleId,
  ExpiryActivatorUserId,
  ExpiryActivatorName,
  ExpiryActivatorDisplayName,
  ExpiryPriority,
  ExpiryTimestamp,
  ExpiryTaskStartElementPid,
  IsExpired,
  ExpiredCreatorTaskId,
  TimeoutedCreatorIntrmdtEventId,
  DelayTimestamp,
  "State",
  RequestPath,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  Priority,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendarId,
  WorkingTime,
  BusinessRuntime,
  FailedTimeoutTimestamp,
  NumberOfFailures,
  NumberOfResumes,
  Category,
  IsUpdatedOnStart,
  IsOffline,
  CurrentPriority,
  CurrentActivatorName,
  CurrentActivatorDisplayName,
  CurrentActivatorRoleId,
  CurrentActivatorUserId,
  BusinessCaseId
)
AS
  SELECT
    IWA_Task.TaskId,
    IWA_Task.CaseId,
    IWA_Task.ProcessModelId,
    IWA_Task.ApplicationId,
    IWA_Task.StartTaskSwitchEventId,
    IWA_Task.EndTaskSwitchEventId,
    IWA_Task.TaskStartId,
    IWA_Task.TaskEndId,
    IWA_Task.WorkerUserId,
    IWA_Task.WorkerUserName,
    CASE WHEN WorkerUserId IS NOT NULL AND LEN(WorkerUser.FullName) > 0 THEN WorkerUser.FullName WHEN WorkerUserId IS NOT NULL THEN WorkerUser.Name ELSE NULL END,
    IWA_Task.WorkerSessionId,
    IWA_Task.ActivatorRoleId,
    IWA_Task.ActivatorUserId,
    IWA_Task.ActivatorName,
    CASE WHEN IWA_Task.ActivatorUserId IS NOT NULL AND LEN(ActivatorUser.FullName) > 0 THEN ActivatorUser.FullName WHEN IWA_Task.ActivatorUserId IS NOT NULL THEN ActivatorUser.Name WHEN IWA_Task.ActivatorRoleId IS NOT NULL AND LEN(ActivatorRole.DisplayNameTemplate) > 0 THEN ActivatorRole.DisplayNameTemplate WHEN IWA_Task.ActivatorRoleId IS NOT NULL THEN ActivatorRole.Name ELSE NULL END,
    IWA_Task.ExpiryActivatorRoleId,
    IWA_Task.ExpiryActivatorUserId,
    IWA_Task.ExpiryActivatorName,
    CASE WHEN IWA_Task.ExpiryActivatorUserId IS NOT NULL AND LEN(ExpiryActivatorUser.FullName) > 0 THEN ExpiryActivatorUser.FullName WHEN IWA_Task.ExpiryActivatorUserId IS NOT NULL THEN ExpiryActivatorUser.Name WHEN IWA_Task.ExpiryActivatorRoleId IS NOT NULL AND LEN(ExpiryActivatorRole.DisplayNameTemplate) > 0 THEN ExpiryActivatorRole.DisplayNameTemplate WHEN IWA_Task.ExpiryActivatorRoleId IS NOT NULL THEN ExpiryActivatorRole.Name ELSE NULL END,
    IWA_Task.ExpiryPriority,
    IWA_Task.ExpiryTimestamp,
    IWA_Task.ExpiryTaskStartElementPid,
    IWA_Task.IsExpired,
    IWA_Task.ExpiredCreatorTaskId,
    IWA_Task.TimeoutedCreatorIntrmdtEventId,
    IWA_Task.DelayTimestamp,
    IWA_Task."State",
    IWA_Task.RequestPath,
    IWA_Task.DisplayNameTemplate,
    IWA_Task.Name,
    IWA_Task.DisplayDescriptionTemplate,
    IWA_Task.Description,
    IWA_Task.Priority,
    IWA_Task.StartTimestamp,
    IWA_Task.EndTimestamp,
    IWA_Task.BusinessCalendarId,
    IWA_Task.WorkingTime,
    IWA_Task.BusinessRuntime,
    IWA_Task.FailedTimeoutTimestamp,
    IWA_Task.NumberOfFailures,
    IWA_Task.NumberOfResumes,
    IWA_Task.Category,
    IWA_Task.IsUpdatedOnStart,
    IWA_Task.IsOffline,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryPriority WHEN 0 THEN IWA_Task.Priority END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorName WHEN 0 THEN IWA_Task.ActivatorName END,
    CASE WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorUserId IS NOT NULL AND LEN(ExpiryActivatorUser.FullName) > 0 THEN ExpiryActivatorUser.FullName WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorUserId IS NOT NULL THEN ExpiryActivatorUser.Name WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorRoleId IS NOT NULL AND LEN(ExpiryActivatorRole.DisplayNameTemplate) > 0 THEN ExpiryActivatorRole.DisplayNameTemplate WHEN IWA_Task.IsExpired = 1 AND IWA_Task.ExpiryActivatorRoleId IS NOT NULL THEN ExpiryActivatorRole.Name WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorUserId IS NOT NULL AND LEN(ActivatorUser.FullName) > 0 THEN ActivatorUser.FullName WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorUserId IS NOT NULL THEN ActivatorUser.Name WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorRoleId IS NOT NULL AND LEN(ActivatorRole.DisplayNameTemplate) > 0 THEN ActivatorRole.DisplayNameTemplate WHEN IWA_Task.IsExpired = 0 AND IWA_Task.ActivatorRoleId IS NOT NULL THEN ActivatorRole.Name ELSE NULL END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorRoleId WHEN 0 THEN IWA_Task.ActivatorRoleId END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorUserId WHEN 0 THEN IWA_Task.ActivatorUserId END,
    IWA_Case.BusinessCaseId
  FROM IWA_Task
    INNER JOIN IWA_Case ON IWA_Task.CaseId = IWA_Case.CaseId
    LEFT OUTER JOIN IWA_User AS ActivatorUser ON IWA_Task.ActivatorUserId = ActivatorUser.UserId
    LEFT OUTER JOIN IWA_Role AS ActivatorRole ON IWA_Task.ActivatorRoleId = ActivatorRole.RoleId
    LEFT OUTER JOIN IWA_User AS ExpiryActivatorUser ON IWA_Task.ExpiryActivatorUserId = ExpiryActivatorUser.UserId
    LEFT OUTER JOIN IWA_Role AS ExpiryActivatorRole ON IWA_Task.ExpiryActivatorRoleId = ExpiryActivatorRole.RoleId
    LEFT OUTER JOIN IWA_User AS WorkerUser ON IWA_Task.WorkerUserId = WorkerUser.UserId
GO

CREATE VIEW IWA_CaseQuery
(
  CaseId,
  BusinessCaseId,
  Kind,
  ApplicationId,
  ProcessModelId,
  TaskStartId,
  CreatorUserId,
  CreatorUserName,
  CreatorUserDisplayName,
  CreatorTaskId,
  EnvironmentId,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendarId,
  WorkingTime,
  BusinessRuntime,
  "State",
  Priority,
  Stage,
  OwnerRoleId,
  OwnerUserId,
  OwnerName,
  Category
)
AS
  SELECT
    IWA_Case.CaseId,
    IWA_Case.BusinessCaseId,
    IWA_Case.Kind,
    IWA_Case.ApplicationId,
    IWA_Case.ProcessModelId,
    IWA_Case.TaskStartId,
    IWA_Case.CreatorUserId,
    IWA_Case.CreatorUserName,
    CASE WHEN IWA_Case.CreatorUserId IS NOT NULL AND LEN(IWA_User.FullName) > 0 THEN IWA_User.FullName WHEN IWA_Case.CreatorUserId IS NOT NULL THEN IWA_User.Name ELSE NULL END,
    IWA_Case.CreatorTaskId,
    IWA_Case.EnvironmentId,
    IWA_Case.DisplayNameTemplate,
    IWA_Case.Name,
    IWA_Case.DisplayDescriptionTemplate,
    IWA_Case.Description,
    IWA_Case.StartTimestamp,
    IWA_Case.EndTimestamp,
    IWA_Case.BusinessCalendarId,
    IWA_Case.WorkingTime,
    IWA_Case.BusinessRuntime,
    IWA_Case."State",
    IWA_Case.Priority,
    IWA_Case.Stage,
    IWA_Case.OwnerRoleId,
    IWA_Case.OwnerUserId,
    IWA_Case.OwnerName,
    IWA_Case.Category
  FROM IWA_Case
    LEFT OUTER JOIN IWA_User ON IWA_Case.CreatorUserId = IWA_User.UserId
GO

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0
GO


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=57
GO
