# SQL script to convert the database for MySQL from version 115 to version 116

UPDATE IWA_SecuritySystem SET Name = 'system' WHERE Name = 'System';

CREATE PROCEDURE create_index_if_not_exists(sqlstatement VARCHAR(256))
BEGIN
  DECLARE already_exists CONDITION FOR SQLSTATE '23000';
  DECLARE columns_indexed CONDITION FOR SQLSTATE '42000';
  DECLARE EXIT HANDLER FOR already_exists, columns_indexed
  BEGIN
    -- ignore exceptions for index already exists or columns already indexed
  END;
  SET @sqlstmt = sqlstatement;
  PREPARE stmt FROM @sqlstmt;
  EXECUTE stmt;
  DEALLOCATE PREPARE stmt;
END;
;

CALL create_index_if_not_exists('CREATE INDEX IWA_BusinessData_TypeIdxSecSysIdx ON IWA_BusinessData (ObjectType(253), SecuritySystemId)');
CALL create_index_if_not_exists('CREATE INDEX IWA_User_SecSysSecMemberIndex ON IWA_User (SecuritySystemId, SecurityMemberId)');
CALL create_index_if_not_exists('CREATE INDEX IWA_User_SecSysNameSecMemberIdx ON IWA_User (SecuritySystemId, Name(50), SecurityMemberId(200))');

DROP PROCEDURE create_index_if_not_exists;

# Update Version
UPDATE IWA_Version SET Version=116;
