# ---------------------------------------------------------------------------------
# 
# Converts the ivy system database from version 36 to version 37
# 
# ---------------------------------------------------------------------------------
# 
# This script was automatically generated. Do not edit it. Instead edit the source file
# 
# ---------------------------------------------------------------------------------
# Database: MySQL
# ---------------------------------------------------------------------------------
# Copyright:
# Axon Ivy AG, Baarerstrasse 12, 6300 Zug
# ---------------------------------------------------------------------------------


# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_RoleDeleteTrigger;

# Create new added tables
CREATE TABLE IWA_RoleRoleMember
(
  RoleId BIGINT NOT NULL,
  RoleMemberId BIGINT NOT NULL,
  PRIMARY KEY (RoleId, RoleMemberId)
) ENGINE=InnoDB;


# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_RoleDeleteTrigger
AFTER DELETE ON IWA_Role
FOR EACH ROW
BEGIN
  UPDATE IWA_Task
  SET State=9, FailedTimeoutTimestamp=NULL, WorkerUserId=NULL, WorkerUserName=NULL
  WHERE ((IWA_Task.ActivatorRoleId=OLD.RoleId AND IWA_Task.IsExpired=0) OR (IWA_Task.ExpiryActivatorRoleId=OLD.RoleId AND IWA_Task.IsExpired=1)) AND (IWA_Task.State=3 OR IWA_Task.State=4 OR IWA_Task.State=8 OR IWA_Task.State=10);

  DELETE FROM IWA_ProcessModelVersionRole
  WHERE IWA_ProcessModelVersionRole.RoleId = OLD.RoleId;

  DELETE FROM IWA_RoleProperty
  WHERE IWA_RoleProperty.RoleId = OLD.RoleId;

  DELETE FROM IWA_RoleRoleMember
  WHERE IWA_RoleRoleMember.RoleId = OLD.RoleId;

  DELETE FROM IWA_RoleRoleMember
  WHERE IWA_RoleRoleMember.RoleMemberId = OLD.RoleId;

  DELETE FROM IWA_UserRole
  WHERE IWA_UserRole.RoleId = OLD.RoleId;

  DELETE FROM IWA_UserSubstitute
  WHERE IWA_UserSubstitute.SubstituteForRoleId = OLD.RoleId;

  UPDATE IWA_StartElement
  SET ActivatorRoleId=NULL
  WHERE IWA_StartElement.ActivatorRoleId=OLD.RoleId;

  UPDATE IWA_StartEventElement
  SET ActivatorRoleId=NULL
  WHERE IWA_StartEventElement.ActivatorRoleId=OLD.RoleId;

  UPDATE IWA_WebServiceProcStartElement
  SET ActivatorRoleId=NULL
  WHERE IWA_WebServiceProcStartElement.ActivatorRoleId=OLD.RoleId;

  UPDATE IWA_Task
  SET ActivatorRoleId=NULL
  WHERE IWA_Task.ActivatorRoleId=OLD.RoleId;

  UPDATE IWA_Task
  SET ExpiryActivatorRoleId=NULL
  WHERE IWA_Task.ExpiryActivatorRoleId=OLD.RoleId;

  DELETE FROM IWA_AccessControl
  WHERE IWA_AccessControl.RoleId = OLD.RoleId;

END
;

# 
# Update Version
# 
UPDATE IWA_Version SET Version=37;
