# ---------------------------------------------------------------------------------
# 
# Converts the ivy system database from version 37 to version 38
# 
# ---------------------------------------------------------------------------------
# 
# This script was automatically generated. Do not edit it. Instead edit the source file
# 
# ---------------------------------------------------------------------------------
# Database: MySQL
# ---------------------------------------------------------------------------------
# Copyright:
# Axon Ivy AG, Baarerstrasse 12, 6300 Zug
# ---------------------------------------------------------------------------------


# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ApplicationDeleteTrigger;

# Create new added tables
CREATE TABLE IWA_RestClient
(
  RestClientId BIGINT NOT NULL,
  UUID VARCHAR(36) NOT NULL,
  ApplicationId BIGINT NOT NULL,
  Name VARCHAR(200) NOT NULL,
  URI VARCHAR(1024),
  PRIMARY KEY (RestClientId)
) ENGINE=InnoDB;

CREATE TABLE IWA_RestClientProperty
(
  RestClientPropertyId BIGINT NOT NULL,
  RestClientId BIGINT NOT NULL,
  Name VARCHAR(200) NOT NULL,
  `Value` VARCHAR(1024) NOT NULL,
  IsPassword BIT NOT NULL,
  PRIMARY KEY (RestClientPropertyId)
) ENGINE=InnoDB;

CREATE TABLE IWA_RestClientFeature
(
  RestClientFeatureId BIGINT NOT NULL,
  RestClientId BIGINT NOT NULL,
  Class VARCHAR(200) NOT NULL,
  PRIMARY KEY (RestClientFeatureId)
) ENGINE=InnoDB;


# Create trigger which depend on new added table
CREATE TRIGGER IWA_RestClientDeleteTrigger
AFTER DELETE ON IWA_RestClient
FOR EACH ROW
BEGIN
  DELETE FROM IWA_RestClientProperty
  WHERE IWA_RestClientProperty.RestClientId = OLD.RestClientId;

  DELETE FROM IWA_RestClientFeature
  WHERE IWA_RestClientFeature.RestClientId = OLD.RestClientId;

END
;


# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ApplicationDeleteTrigger
AFTER DELETE ON IWA_Application
FOR EACH ROW
BEGIN
  DELETE FROM IWA_ApplicationProperty
  WHERE IWA_ApplicationProperty.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_Environment
  WHERE IWA_Environment.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_GlobalVariable
  WHERE IWA_GlobalVariable.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_ExternalNamingAndDirectory
  WHERE IWA_ExternalNamingAndDirectory.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_ExternalDatabase
  WHERE IWA_ExternalDatabase.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_ProcessModel
  WHERE IWA_ProcessModel.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_Role
  WHERE IWA_Role.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_User
  WHERE IWA_User.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_SignalEvent
  WHERE IWA_SignalEvent.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_ContentManagementSystem
  WHERE IWA_ContentManagementSystem.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_RestClient
  WHERE IWA_RestClient.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_SecurityDescriptor
  WHERE IWA_SecurityDescriptor.SecurityDescriptorId = OLD.SecurityDescriptorId;

END
;

# Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0;


# 
# Update Version
# 
UPDATE IWA_Version SET Version=38;
