# ---------------------------------------------------------------------------------
# 
# Converts the ivy system database from version 44 to version 45
# 
# ---------------------------------------------------------------------------------
# 
# This script was automatically generated. Do not edit it. Instead edit the source file
# 
# ---------------------------------------------------------------------------------
# Database: MySQL
# ---------------------------------------------------------------------------------
# Copyright:
# Axon Ivy AG, Baarerstrasse 12, 6300 Zug
# ---------------------------------------------------------------------------------


# Create new added tables
CREATE TABLE IWA_CaseMap
(
  CaseMapId BIGINT NOT NULL,
  ProcessModelVersionId BIGINT NOT NULL,
  ApplicationId BIGINT NOT NULL,
  UUID VARCHAR(36) NOT NULL,
  Name VARCHAR(200) NOT NULL,
  Model TEXT NOT NULL,
  PRIMARY KEY (CaseMapId),
  FOREIGN KEY (ProcessModelVersionId) REFERENCES IWA_ProcessModelVersion(ProcessModelVersionId) ON DELETE CASCADE,
  FOREIGN KEY (ApplicationId) REFERENCES IWA_Application(ApplicationId) ON DELETE CASCADE,
  UNIQUE (ProcessModelVersionId, UUID)
) ENGINE=InnoDB;

CREATE TABLE IWA_CaseMapBusinessCase
(
  BusinessCaseId BIGINT NOT NULL,
  CaseMapId BIGINT NOT NULL,
  PRIMARY KEY (BusinessCaseId),
  FOREIGN KEY (BusinessCaseId) REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  FOREIGN KEY (CaseMapId) REFERENCES IWA_CaseMap(CaseMapId) ON DELETE CASCADE,
  INDEX IWA_CaseMapBusCase_CsMpIdIdx (CaseMapId)
) ENGINE=InnoDB;

CREATE TABLE IWA_CaseMapEvent
(
  CaseMapEventId BIGINT NOT NULL,
  BusinessCaseId BIGINT NOT NULL,
  `Timestamp` DATETIME NOT NULL,
  Kind INTEGER NOT NULL,
  Stage VARCHAR(200) NOT NULL,
  Process VARCHAR(200) NOT NULL,
  ProcessCaseId BIGINT,
  Milestone VARCHAR(200) NOT NULL,
  Reason VARCHAR(200) NOT NULL,
  ProcessingState INTEGER NOT NULL,
  ProcessingErrorMessage VARCHAR(750) NOT NULL,
  ProcessingErrorCount INTEGER NOT NULL,
  ProcessingRetryTimestamp DATETIME,
  PRIMARY KEY (CaseMapEventId),
  FOREIGN KEY (BusinessCaseId) REFERENCES IWA_CaseMapBusinessCase(BusinessCaseId) ON DELETE CASCADE,
  FOREIGN KEY (ProcessCaseId) REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  INDEX IWA_CaseMapEvent_BcId (BusinessCaseId),
  INDEX IWA_CaseMapEvent_PrcRtryTstmp (ProcessingRetryTimestamp),
  INDEX IWA_CaseMapEvent_PrcState (ProcessingState)
) ENGINE=InnoDB;

CREATE TABLE IWA_BusinessCaseData
(
  BusinessDataId VARCHAR(100) NOT NULL,
  ObjectType VARCHAR(255) NOT NULL,
  BusinessCaseId BIGINT NOT NULL,
  PRIMARY KEY (BusinessDataId),
  FOREIGN KEY (BusinessCaseId) REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  UNIQUE (BusinessCaseId, ObjectType)
) ENGINE=InnoDB;

# Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0;


# 
# Update Version
# 
UPDATE IWA_Version SET Version=45;
