# ---------------------------------------------------------------------------------
# 
# Converts the ivy system database from version 69 to version 70
# 
# ---------------------------------------------------------------------------------
# 
# This script was automatically generated. Do not edit it. Instead edit the source file
# 
# ---------------------------------------------------------------------------------
# Database: MySQL
# ---------------------------------------------------------------------------------
# Copyright:
# Axon Ivy AG, Baarerstrasse 12, 6300 Zug
# ---------------------------------------------------------------------------------


# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ApplicationDeleteTrigger;

# Drop trigger which depend on changed table(s)
DROP TRIGGER IWA_ProcessModelVersionDeleteTrigger;

# Drop trigger that has been deleted
DROP TRIGGER IWA_ContentManagementSystemDeleteTrigger;
# Store Procedure to drop a foreign key constraint
CREATE PROCEDURE IWA_Drop_ForeignKey_Constraint(fk_schema VARCHAR(64), fk_table VARCHAR(64), fk_column VARCHAR(64))
BEGIN
  WHILE EXISTS(
    SELECT * FROM INFORMATION_SCHEMA.KEY_COLUMN_USAGE
    WHERE REFERENCED_COLUMN_NAME IS NOT NULL
      AND CAST(TABLE_SCHEMA AS CHAR CHARACTER SET ascii) COLLATE ascii_general_ci = CAST(fk_schema AS CHAR CHARACTER SET ascii)
      AND CAST(TABLE_NAME AS CHAR CHARACTER SET ascii) COLLATE ascii_general_ci = CAST(fk_table AS CHAR CHARACTER SET ascii)
      AND CAST(COLUMN_NAME AS CHAR CHARACTER SET ascii) COLLATE ascii_general_ci = CAST(fk_column AS CHAR CHARACTER SET ascii)
  ) 
  DO
    BEGIN
      SET @sqlstmt = (
        SELECT CONCAT('ALTER TABLE ',TABLE_SCHEMA,'.',TABLE_NAME,' DROP FOREIGN KEY ',CONSTRAINT_NAME)
        FROM INFORMATION_SCHEMA.KEY_COLUMN_USAGE
        WHERE REFERENCED_COLUMN_NAME IS NOT NULL
          AND CAST(TABLE_SCHEMA AS CHAR CHARACTER SET ascii) COLLATE ascii_general_ci = CAST(fk_schema AS CHAR CHARACTER SET ascii)
          AND CAST(TABLE_NAME AS CHAR CHARACTER SET ascii) COLLATE ascii_general_ci = CAST(fk_table AS CHAR CHARACTER SET ascii)
          AND CAST(COLUMN_NAME AS CHAR CHARACTER SET ascii) COLLATE ascii_general_ci = CAST(fk_column AS CHAR CHARACTER SET ascii)
        LIMIT 1
      );
      PREPARE stmt1 FROM @sqlstmt;
      EXECUTE stmt1;
    END;
  END WHILE;
END;
;

CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_EventLogData', 'EventLogId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_EventLogTaskHistory', 'EventLogId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_EventLogStatus', 'EventLogId');
CALL IWA_Drop_ForeignKey_Constraint(SCHEMA(), 'IWA_ContentObject', 'ParentContentObjectId');

# Drop trigger of no longer exisiting table
DROP TRIGGER IWA_ContentObjectValueDeleteTrigger;

# Drop trigger of no longer exisiting table
DROP TRIGGER IWA_ContentObjectDeleteTrigger;

# Drop no longer exisiting table
DROP TABLE IWA_EventLogData;

# Drop no longer exisiting table
DROP TABLE IWA_EventLogTaskHistory;

# Drop no longer exisiting table
DROP TABLE IWA_EventLogCaseHistory;

# Drop no longer exisiting table
DROP TABLE IWA_EventLogStatus;

# Drop no longer exisiting table
DROP TABLE IWA_EventLog;

# Drop no longer exisiting table
DROP TABLE IWA_SupportedLanguage;

# Drop no longer exisiting table
DROP TABLE IWA_ContentDataString;

# Drop no longer exisiting table
DROP TABLE IWA_ContentDataText;

# Drop no longer exisiting table
DROP TABLE IWA_ContentDataImage;

# Drop no longer exisiting table
DROP TABLE IWA_ContentObjectValue;

# Drop no longer exisiting table
ALTER TABLE IWA_ContentManagementSystem DROP COLUMN DefaultPageLayoutId;
ALTER TABLE IWA_ContentManagementSystem DROP COLUMN DefaultPageStyleSheetId;
DROP TABLE IWA_ContentObject;

# Drop no longer exisiting table
DROP TABLE IWA_ContentObjectType;

# Drop no longer exisiting table
DROP TABLE IWA_ContentManagementSystem;

# Drop temporary created stored procedures needed for conversion
DROP PROCEDURE IWA_Drop_ForeignKey_Constraint;

# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ApplicationDeleteTrigger
AFTER DELETE ON IWA_Application
FOR EACH ROW
BEGIN
  DELETE FROM IWA_Environment
  WHERE IWA_Environment.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_ExternalDatabase
  WHERE IWA_ExternalDatabase.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_SignalEvent
  WHERE IWA_SignalEvent.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_Role
  WHERE IWA_Role.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_ApplicationProperty
  WHERE IWA_ApplicationProperty.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_GlobalVariable
  WHERE IWA_GlobalVariable.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_ExternalNamingAndDirectory
  WHERE IWA_ExternalNamingAndDirectory.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_RestServiceClient
  WHERE IWA_RestServiceClient.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_User
  WHERE IWA_User.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_ProcessModel
  WHERE IWA_ProcessModel.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_SecurityMember
  WHERE IWA_SecurityMember.ApplicationId = OLD.ApplicationId;

  DELETE FROM IWA_SecurityDescriptor
  WHERE IWA_SecurityDescriptor.SecurityDescriptorId = OLD.SecurityDescriptorId;

END
;

# Recreate trigger which depend on changed table(s)
CREATE TRIGGER IWA_ProcessModelVersionDeleteTrigger
AFTER DELETE ON IWA_ProcessModelVersion
FOR EACH ROW
BEGIN
  DELETE FROM IWA_TaskElement
  WHERE IWA_TaskElement.ProcessModelVersionId = OLD.ProcessModelVersionId;

  DELETE FROM IWA_WebServiceProcess
  WHERE IWA_WebServiceProcess.ProcessModelVersionId = OLD.ProcessModelVersionId;

  DELETE FROM IWA_PageElement
  WHERE IWA_PageElement.ProcessModelVersionId = OLD.ProcessModelVersionId;

END
;

# 
# Update Version
# 
UPDATE IWA_Version SET Version=70;
