-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 34 to version 35
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Oracle
-- ---------------------------------------------------------------------------------
-- Copyright:
-- ivyTeam AG, Alpenstrasse 9, 6304 Zug
-- ---------------------------------------------------------------------------------

-- Drop views which depend on changed tables
DROP VIEW IWA_TaskQuery;


-- Create new added tables
CREATE TABLE IWA_UserLocation
(
  UserLocationId NUMBER(20) NOT NULL,
  UserId NUMBER(20) NOT NULL REFERENCES IWA_User(UserId) ON DELETE CASCADE,
  "TYPE" VARCHAR2(200) NOT NULL,
  Note VARCHAR2(2000) NOT NULL,
  Name VARCHAR2(200) NOT NULL,
  Address VARCHAR2(200) NOT NULL,
  Latitude DECIMAL(10, 8) NOT NULL,
  Longitude DECIMAL(11, 8) NOT NULL,
  Altitude DECIMAL(8, 3) NOT NULL,
  AccuracyHorizontal DECIMAL(8, 3),
  AccuracyVertical DECIMAL(8, 3),
  Speed DECIMAL(8, 3),
  Bearing DECIMAL(6, 3),
  LocationTimestamp DATE,
  PRIMARY KEY (UserLocationId)
)
TABLESPACE ${tablespaceName};

CREATE TABLE IWA_TaskLocation
(
  TaskLocationId NUMBER(20) NOT NULL,
  TaskId NUMBER(20) NOT NULL REFERENCES IWA_Task(TaskId) ON DELETE CASCADE,
  "TYPE" VARCHAR2(200) NOT NULL,
  Note VARCHAR2(2000) NOT NULL,
  Name VARCHAR2(200) NOT NULL,
  Address VARCHAR2(200) NOT NULL,
  Latitude DECIMAL(10, 8) NOT NULL,
  Longitude DECIMAL(11, 8) NOT NULL,
  Altitude DECIMAL(8, 3) NOT NULL,
  AccuracyHorizontal DECIMAL(8, 3),
  AccuracyVertical DECIMAL(8, 3),
  Speed DECIMAL(8, 3),
  Bearing DECIMAL(6, 3),
  LocationTimestamp DATE,
  PRIMARY KEY (TaskLocationId)
)
TABLESPACE ${tablespaceName};


-- Changed columns of table IWA_Application
ALTER TABLE IWA_Application MODIFY OwnerPassword  VARCHAR2(200);
ALTER TABLE IWA_Application MODIFY DownloadPassword  VARCHAR2(200);


-- Changed columns of table IWA_ExternalNamingAndDirectory
ALTER TABLE IWA_ExternalNamingAndDirectory MODIFY UserPassword  VARCHAR2(200);


-- Changed columns of table IWA_ExternalDatabase
ALTER TABLE IWA_ExternalDatabase MODIFY UserPassword  VARCHAR2(200);


-- Changed columns of table IWA_User
ALTER TABLE IWA_User MODIFY UserPassword  VARCHAR2(200);


-- Added columns of table IWA_Task
ALTER TABLE IWA_Task ADD
  IsOffline NUMBER(1) DEFAULT 0 NOT NULL;

-- Create new indexes of table IWA_Role
CREATE INDEX IWA_Role_ExternalSecNameIdx
ON IWA_Role (ApplicationId, ExternalSecurityName)
TABLESPACE ${tablespaceName};


-- Create new indexes of table IWA_User
CREATE INDEX IWA_User_ExternalSecNameIdx
ON IWA_User (ApplicationId, ExternalSecurityName)
TABLESPACE ${tablespaceName};


-- Create new indexes of table IWA_Case
CREATE INDEX IWA_Case_NameIndex
ON IWA_Case (Name)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Case_CustVarCharFld1Idx
ON IWA_Case (CustomVarCharField1)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Case_CustVarCharFld2Idx
ON IWA_Case (CustomVarCharField2)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Case_CustVarCharFld3Idx
ON IWA_Case (CustomVarCharField3)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Case_CustVarCharFld4Idx
ON IWA_Case (CustomVarCharField4)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Case_CustVarCharFld5Idx
ON IWA_Case (CustomVarCharField5)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Case_CustDecimalFld1Idx
ON IWA_Case (CustomDecimalField1)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Case_CustDecimalFld2Idx
ON IWA_Case (CustomDecimalField2)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Case_CustDecimalFld3Idx
ON IWA_Case (CustomDecimalField3)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Case_CustDecimalFld4Idx
ON IWA_Case (CustomDecimalField4)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Case_CustDecimalFld5Idx
ON IWA_Case (CustomDecimalField5)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Case_CustTimestmpFld1Idx
ON IWA_Case (CustomTimestampField1)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Case_CustTimestmpFld2Idx
ON IWA_Case (CustomTimestampField2)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Case_CustTimestmpFld3Idx
ON IWA_Case (CustomTimestampField3)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Case_CustTimestmpFld4Idx
ON IWA_Case (CustomTimestampField4)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Case_CustTimestmpFld5Idx
ON IWA_Case (CustomTimestampField5)
TABLESPACE ${tablespaceName};


-- Create new indexes of table IWA_Task
CREATE INDEX IWA_Task_NameIndex
ON IWA_Task (Name)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Task_CustVarCharFld1Idx
ON IWA_Task (CustomVarCharField1)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Task_CustVarCharFld2Idx
ON IWA_Task (CustomVarCharField2)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Task_CustVarCharFld3Idx
ON IWA_Task (CustomVarCharField3)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Task_CustVarCharFld4Idx
ON IWA_Task (CustomVarCharField4)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Task_CustVarCharFld5Idx
ON IWA_Task (CustomVarCharField5)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Task_CustDecimalFld1Idx
ON IWA_Task (CustomDecimalField1)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Task_CustDecimalFld2Idx
ON IWA_Task (CustomDecimalField2)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Task_CustDecimalFld3Idx
ON IWA_Task (CustomDecimalField3)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Task_CustDecimalFld4Idx
ON IWA_Task (CustomDecimalField4)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Task_CustDecimalFld5Idx
ON IWA_Task (CustomDecimalField5)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Task_CustTimestmpFld1Idx
ON IWA_Task (CustomTimestampField1)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Task_CustTimestmpFld2Idx
ON IWA_Task (CustomTimestampField2)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Task_CustTimestmpFld3Idx
ON IWA_Task (CustomTimestampField3)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Task_CustTimestmpFld4Idx
ON IWA_Task (CustomTimestampField4)
TABLESPACE ${tablespaceName};

CREATE INDEX IWA_Task_CustTimestmpFld5Idx
ON IWA_Task (CustomTimestampField5)
TABLESPACE ${tablespaceName};


-- Create new indexes of table IWA_EventLogStatus
CREATE INDEX IWA_EventLogStatus_StEvtLgIdx
ON IWA_EventLogStatus (Status, EventLogId)
TABLESPACE ${tablespaceName};


-- Recreate views which depend on changed tables
CREATE VIEW IWA_TaskQuery
(
  TaskId,
  CaseId,
  ProcessModelId,
  ApplicationId,
  StartTaskSwitchEventId,
  EndTaskSwitchEventId,
  TaskStartId,
  TaskEndId,
  WorkerUserId,
  WorkerUserName,
  WorkerSessionId,
  ActivatorRoleId,
  ActivatorUserId,
  ActivatorName,
  ExpiryActivatorRoleId,
  ExpiryActivatorUserId,
  ExpiryActivatorName,
  ExpiryPriority,
  ExpiryTimestamp,
  ExpiryTaskStartElementPid,
  IsExpired,
  ExpiredCreatorTaskId,
  TimeoutedCreatorIntrmdtEventId,
  DelayTimestamp,
  State,
  RequestPath,
  DisplayNameTemplate,
  Name,
  DisplayDescriptionTemplate,
  Description,
  Priority,
  StartTimestamp,
  EndTimestamp,
  BusinessCalendarId,
  WorkingTime,
  BusinessRuntime,
  FailedTimeoutTimestamp,
  NumberOfFailures,
  NumberOfResumes,
  KindCode,
  KindName,
  BusinessMilestoneTimestamp,
  CustomVarCharField1,
  CustomVarCharField2,
  CustomVarCharField3,
  CustomVarCharField4,
  CustomVarCharField5,
  CustomDecimalField1,
  CustomDecimalField2,
  CustomDecimalField3,
  CustomDecimalField4,
  CustomDecimalField5,
  CustomTimestampField1,
  CustomTimestampField2,
  CustomTimestampField3,
  CustomTimestampField4,
  CustomTimestampField5,
  IsUpdatedOnStart,
  IsOffline,
  CurrentPriority,
  CurrentActivatorName,
  CurrentActivatorRoleId,
  CurrentActivatorUserId,
  ProcessCategoryCode,
  ProcessCategoryName,
  ProcessCode,
  ProcessName,
  TypeCode,
  TypeName,
  SubTypeCode,
  SubTypeName,
  BusinessObjectCode,
  BusinessObjectName,
  BusinessMainContactId,
  BusinessMainContactName,
  BusinessStartTimestamp,
  BusinessCreatorUser
)
AS
  SELECT
    IWA_Task.TaskId,
    IWA_Task.CaseId,
    IWA_Task.ProcessModelId,
    IWA_Task.ApplicationId,
    IWA_Task.StartTaskSwitchEventId,
    IWA_Task.EndTaskSwitchEventId,
    IWA_Task.TaskStartId,
    IWA_Task.TaskEndId,
    IWA_Task.WorkerUserId,
    IWA_Task.WorkerUserName,
    IWA_Task.WorkerSessionId,
    IWA_Task.ActivatorRoleId,
    IWA_Task.ActivatorUserId,
    IWA_Task.ActivatorName,
    IWA_Task.ExpiryActivatorRoleId,
    IWA_Task.ExpiryActivatorUserId,
    IWA_Task.ExpiryActivatorName,
    IWA_Task.ExpiryPriority,
    IWA_Task.ExpiryTimestamp,
    IWA_Task.ExpiryTaskStartElementPid,
    IWA_Task.IsExpired,
    IWA_Task.ExpiredCreatorTaskId,
    IWA_Task.TimeoutedCreatorIntrmdtEventId,
    IWA_Task.DelayTimestamp,
    IWA_Task.State,
    IWA_Task.RequestPath,
    IWA_Task.DisplayNameTemplate,
    IWA_Task.Name,
    IWA_Task.DisplayDescriptionTemplate,
    IWA_Task.Description,
    IWA_Task.Priority,
    IWA_Task.StartTimestamp,
    IWA_Task.EndTimestamp,
    IWA_Task.BusinessCalendarId,
    IWA_Task.WorkingTime,
    IWA_Task.BusinessRuntime,
    IWA_Task.FailedTimeoutTimestamp,
    IWA_Task.NumberOfFailures,
    IWA_Task.NumberOfResumes,
    IWA_Task.KindCode,
    IWA_Task.KindName,
    IWA_Task.BusinessMilestoneTimestamp,
    IWA_Task.CustomVarCharField1,
    IWA_Task.CustomVarCharField2,
    IWA_Task.CustomVarCharField3,
    IWA_Task.CustomVarCharField4,
    IWA_Task.CustomVarCharField5,
    IWA_Task.CustomDecimalField1,
    IWA_Task.CustomDecimalField2,
    IWA_Task.CustomDecimalField3,
    IWA_Task.CustomDecimalField4,
    IWA_Task.CustomDecimalField5,
    IWA_Task.CustomTimestampField1,
    IWA_Task.CustomTimestampField2,
    IWA_Task.CustomTimestampField3,
    IWA_Task.CustomTimestampField4,
    IWA_Task.CustomTimestampField5,
    IWA_Task.IsUpdatedOnStart,
    IWA_Task.IsOffline,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryPriority WHEN 0 THEN IWA_Task.Priority END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorName WHEN 0 THEN IWA_Task.ActivatorName END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorRoleId WHEN 0 THEN IWA_Task.ActivatorRoleId END,
    CASE IWA_Task.IsExpired WHEN 1 THEN IWA_Task.ExpiryActivatorUserId WHEN 0 THEN IWA_Task.ActivatorUserId END,
    IWA_Case.ProcessCategoryCode,
    IWA_Case.ProcessCategoryName,
    IWA_Case.ProcessCode,
    IWA_Case.ProcessName,
    IWA_Case.TypeCode,
    IWA_Case.TypeName,
    IWA_Case.SubTypeCode,
    IWA_Case.SubTypeName,
    IWA_Case.BusinessObjectCode,
    IWA_Case.BusinessObjectName,
    IWA_Case.BusinessMainContactId,
    IWA_Case.BusinessMainContactName,
    IWA_Case.BusinessStartTimestamp,
    IWA_Case.BusinessCreatorUser
  FROM IWA_Task, IWA_Case
  WHERE IWA_Task.CaseId = IWA_Case.CaseId;

-- Add new added default table content
INSERT INTO IWA_Permission (PermissionId, Name) VALUES (586, 'DocumentRead');

INSERT INTO IWA_Permission (PermissionId, Name) VALUES (587, 'DocumentWrite');

INSERT INTO IWA_Permission (PermissionId, Name) VALUES (588, 'DocumentOfInvolvedCaseRead');

INSERT INTO IWA_Permission (PermissionId, Name) VALUES (589, 'DocumentOfInvolvedCaseWrite');

INSERT INTO IWA_PermissionGroup (PermissionGroupId, ParentPermissionGroupId, Name) VALUES (89, 6, 'DocumentPermissions');

INSERT INTO IWA_PermissionGroup (PermissionGroupId, ParentPermissionGroupId, Name) VALUES (90, 13, 'SystemwideDocumentPermissions');

INSERT INTO IWA_PermissionGroupPermission (PermissionGroupId, PermissionId) VALUES (89, 586);

INSERT INTO IWA_PermissionGroupPermission (PermissionGroupId, PermissionId) VALUES (89, 587);

INSERT INTO IWA_PermissionGroupPermission (PermissionGroupId, PermissionId) VALUES (89, 588);

INSERT INTO IWA_PermissionGroupPermission (PermissionGroupId, PermissionId) VALUES (89, 589);

INSERT INTO IWA_PermissionGroupPermission (PermissionGroupId, PermissionId) VALUES (90, 586);

INSERT INTO IWA_PermissionGroupPermission (PermissionGroupId, PermissionId) VALUES (90, 587);

INSERT INTO IWA_PermissionGroupPermission (PermissionGroupId, PermissionId) VALUES (90, 588);

INSERT INTO IWA_PermissionGroupPermission (PermissionGroupId, PermissionId) VALUES (90, 589);

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0;


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=35;
