-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 38 to version 39
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Oracle
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------


-- Drop no longer exisiting table
DROP TABLE IWA_RestClientProperty;

-- Drop no longer exisiting table
DROP TABLE IWA_RestClientFeature;

-- Drop no longer exisiting table
DROP TABLE IWA_RestClient;

-- Create new added tables
CREATE TABLE IWA_RestServiceClient
(
  RestClientId NUMBER(20) NOT NULL,
  ParentRestClientId NUMBER(20),
  UUID VARCHAR2(36) NOT NULL,
  ApplicationId NUMBER(20) NOT NULL REFERENCES IWA_Application(ApplicationId) ON DELETE CASCADE,
  EnvironmentId NUMBER(20) REFERENCES IWA_Environment(EnvironmentId) ON DELETE CASCADE,
  Name VARCHAR2(200) NOT NULL,
  Description VARCHAR2(2000),
  URI VARCHAR2(1024),
  PRIMARY KEY (RestClientId),
  UNIQUE (ApplicationId, ParentRestClientId, EnvironmentId, UUID),
  UNIQUE (ApplicationId, ParentRestClientId, EnvironmentId, Name)
)
TABLESPACE ${tablespaceName};

CREATE TABLE IWA_RestServiceClientProperty
(
  RestClientPropertyId NUMBER(20) NOT NULL,
  RestClientId NUMBER(20) NOT NULL REFERENCES IWA_RestServiceClient(RestClientId) ON DELETE CASCADE,
  Name VARCHAR2(200) NOT NULL,
  "VALUE" VARCHAR2(1024) NOT NULL,
  IsPassword NUMBER(1) NOT NULL,
  PRIMARY KEY (RestClientPropertyId)
)
TABLESPACE ${tablespaceName};

CREATE TABLE IWA_RestServiceClientFeature
(
  RestClientFeatureId NUMBER(20) NOT NULL,
  RestClientId NUMBER(20) NOT NULL REFERENCES IWA_RestServiceClient(RestClientId) ON DELETE CASCADE,
  Class VARCHAR2(200) NOT NULL,
  PRIMARY KEY (RestClientFeatureId)
)
TABLESPACE ${tablespaceName};

ALTER TABLE IWA_RestServiceClient ADD
(
 FOREIGN KEY (ParentRestClientId) REFERENCES IWA_RestServiceClient(RestClientId) ON DELETE CASCADE
);

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0;


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=39;
