-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 38 to version 39
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Postgre SQL
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------


-- Drop no longer exisiting table
DROP TABLE IWA_RestClientProperty;

-- Drop no longer exisiting table
DROP TABLE IWA_RestClientFeature;

-- Drop no longer exisiting table
DROP TABLE IWA_RestClient;

-- Create new added tables
CREATE TABLE IWA_RestServiceClient
(
  RestClientId BIGINT NOT NULL,
  ParentRestClientId BIGINT,
  UUID VARCHAR(36) NOT NULL,
  ApplicationId BIGINT NOT NULL REFERENCES IWA_Application(ApplicationId) ON DELETE CASCADE,
  EnvironmentId BIGINT REFERENCES IWA_Environment(EnvironmentId) ON DELETE CASCADE,
  Name VARCHAR(200) NOT NULL,
  Description VARCHAR(2000) NOT NULL,
  URI VARCHAR(1024),
  PRIMARY KEY (RestClientId),
  UNIQUE (ApplicationId, ParentRestClientId, EnvironmentId, UUID),
  UNIQUE (ApplicationId, ParentRestClientId, EnvironmentId, Name)
);

CREATE TABLE IWA_RestServiceClientProperty
(
  RestClientPropertyId BIGINT NOT NULL,
  RestClientId BIGINT NOT NULL REFERENCES IWA_RestServiceClient(RestClientId) ON DELETE CASCADE,
  Name VARCHAR(200) NOT NULL,
  "Value" VARCHAR(1024) NOT NULL,
  IsPassword DECIMAL(1) NOT NULL,
  PRIMARY KEY (RestClientPropertyId)
);

CREATE TABLE IWA_RestServiceClientFeature
(
  RestClientFeatureId BIGINT NOT NULL,
  RestClientId BIGINT NOT NULL REFERENCES IWA_RestServiceClient(RestClientId) ON DELETE CASCADE,
  Class VARCHAR(200) NOT NULL,
  PRIMARY KEY (RestClientFeatureId)
);

ALTER TABLE IWA_RestServiceClient ADD FOREIGN KEY (ParentRestClientId) REFERENCES IWA_RestServiceClient(RestClientId) ON DELETE CASCADE;

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0;


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=39;
