-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 44 to version 45
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Postgre SQL
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------


-- Create new added tables
CREATE TABLE IWA_CaseMap
(
  CaseMapId BIGINT NOT NULL,
  ProcessModelVersionId BIGINT NOT NULL REFERENCES IWA_ProcessModelVersion(ProcessModelVersionId) ON DELETE CASCADE,
  ApplicationId BIGINT NOT NULL REFERENCES IWA_Application(ApplicationId) ON DELETE CASCADE,
  UUID VARCHAR(36) NOT NULL,
  Name VARCHAR(200) NOT NULL,
  Model TEXT NOT NULL,
  PRIMARY KEY (CaseMapId),
  UNIQUE (ProcessModelVersionId, UUID)
);

CREATE TABLE IWA_CaseMapBusinessCase
(
  BusinessCaseId BIGINT NOT NULL REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  CaseMapId BIGINT NOT NULL REFERENCES IWA_CaseMap(CaseMapId) ON DELETE CASCADE,
  PRIMARY KEY (BusinessCaseId)
);

CREATE INDEX IWA_CaseMapBusCase_CsMpIdIdx
ON IWA_CaseMapBusinessCase (CaseMapId);

CREATE TABLE IWA_CaseMapEvent
(
  CaseMapEventId BIGINT NOT NULL,
  BusinessCaseId BIGINT NOT NULL REFERENCES IWA_CaseMapBusinessCase(BusinessCaseId) ON DELETE CASCADE,
  "Timestamp" TIMESTAMP NOT NULL,
  Kind INTEGER NOT NULL,
  Stage VARCHAR(200) NOT NULL,
  Process VARCHAR(200) NOT NULL,
  ProcessCaseId BIGINT REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  Milestone VARCHAR(200) NOT NULL,
  Reason VARCHAR(200) NOT NULL,
  ProcessingState INTEGER NOT NULL,
  ProcessingErrorMessage VARCHAR(750) NOT NULL,
  ProcessingErrorCount INTEGER NOT NULL,
  ProcessingRetryTimestamp TIMESTAMP,
  PRIMARY KEY (CaseMapEventId)
);

CREATE INDEX IWA_CaseMapEvent_BcId
ON IWA_CaseMapEvent (BusinessCaseId);

CREATE INDEX IWA_CaseMapEvent_PrcRtryTstmp
ON IWA_CaseMapEvent (ProcessingRetryTimestamp);

CREATE INDEX IWA_CaseMapEvent_PrcState
ON IWA_CaseMapEvent (ProcessingState);

CREATE TABLE IWA_BusinessCaseData
(
  BusinessDataId VARCHAR(100) NOT NULL,
  ObjectType VARCHAR(255) NOT NULL,
  BusinessCaseId BIGINT NOT NULL REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  PRIMARY KEY (BusinessDataId),
  UNIQUE (BusinessCaseId, ObjectType)
);

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0;


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=45;
