-- ---------------------------------------------------------------------------------
-- 
-- Converts the ivy system database from version 50 to version 51
-- 
-- ---------------------------------------------------------------------------------
-- 
-- This script was automatically generated. Do not edit it. Instead edit the source file
-- 
-- ---------------------------------------------------------------------------------
-- Database: Postgre SQL
-- ---------------------------------------------------------------------------------
-- Copyright:
-- Axon Ivy AG, Baarerstrasse 12, 6300 Zug
-- ---------------------------------------------------------------------------------


-- Drop no longer exisiting table
DROP TABLE IWA_RichDialogUserContext;

-- Create new added tables
CREATE TABLE IWA_TaskCustomStringField
(
  TaskCustomStringFieldId BIGINT NOT NULL,
  TaskId BIGINT NOT NULL REFERENCES IWA_Task(TaskId) ON DELETE CASCADE,
  Name VARCHAR(200) NOT NULL,
  "Value" VARCHAR(2000) NOT NULL,
  PRIMARY KEY (TaskCustomStringFieldId),
  UNIQUE (TaskId, Name)
);

CREATE INDEX IWA_TaskCstmStringFldValueIdx
ON IWA_TaskCustomStringField ("Value" varchar_pattern_ops);

CREATE TABLE IWA_TaskCustomTextField
(
  TaskCustomTextFieldId BIGINT NOT NULL,
  TaskId BIGINT NOT NULL REFERENCES IWA_Task(TaskId) ON DELETE CASCADE,
  Name VARCHAR(200) NOT NULL,
  "Value" TEXT NOT NULL,
  PRIMARY KEY (TaskCustomTextFieldId),
  UNIQUE (TaskId, Name)
);

CREATE TABLE IWA_TaskCustomNumberField
(
  TaskCustomNumberFieldId BIGINT NOT NULL,
  TaskId BIGINT NOT NULL REFERENCES IWA_Task(TaskId) ON DELETE CASCADE,
  Name VARCHAR(200) NOT NULL,
  "Value" DECIMAL(30, 10) NOT NULL,
  PRIMARY KEY (TaskCustomNumberFieldId),
  UNIQUE (TaskId, Name)
);

CREATE INDEX IWA_TaskCstmNumberFldValueIdx
ON IWA_TaskCustomNumberField ("Value");

CREATE TABLE IWA_TaskCustomTimestampField
(
  TaskCustomTimestampFieldId BIGINT NOT NULL,
  TaskId BIGINT NOT NULL REFERENCES IWA_Task(TaskId) ON DELETE CASCADE,
  Name VARCHAR(200) NOT NULL,
  "Value" TIMESTAMP NOT NULL,
  PRIMARY KEY (TaskCustomTimestampFieldId),
  UNIQUE (TaskId, Name)
);

CREATE INDEX IWA_TaskCstmTmstmpFldValIdx
ON IWA_TaskCustomTimestampField ("Value");

CREATE TABLE IWA_CaseCustomStringField
(
  CaseCustomStringFieldId BIGINT NOT NULL,
  CaseId BIGINT NOT NULL REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  Name VARCHAR(200) NOT NULL,
  "Value" VARCHAR(2000) NOT NULL,
  PRIMARY KEY (CaseCustomStringFieldId),
  UNIQUE (CaseId, Name)
);

CREATE INDEX IWA_CaseCstmStringFldValueIdx
ON IWA_CaseCustomStringField ("Value" varchar_pattern_ops);

CREATE TABLE IWA_CaseCustomTextField
(
  CaseCustomTextFieldId BIGINT NOT NULL,
  CaseId BIGINT NOT NULL REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  Name VARCHAR(200) NOT NULL,
  "Value" TEXT NOT NULL,
  PRIMARY KEY (CaseCustomTextFieldId),
  UNIQUE (CaseId, Name)
);

CREATE TABLE IWA_CaseCustomNumberField
(
  CaseCustomNumberFieldId BIGINT NOT NULL,
  CaseId BIGINT NOT NULL REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  Name VARCHAR(200) NOT NULL,
  "Value" DECIMAL(30, 10) NOT NULL,
  PRIMARY KEY (CaseCustomNumberFieldId),
  UNIQUE (CaseId, Name)
);

CREATE INDEX IWA_CaseCstmNubmerFldValueIdx
ON IWA_CaseCustomNumberField ("Value");

CREATE TABLE IWA_CaseCustomTimestampField
(
  CaseCustomTimestampFieldId BIGINT NOT NULL,
  CaseId BIGINT NOT NULL REFERENCES IWA_Case(CaseId) ON DELETE CASCADE,
  Name VARCHAR(200) NOT NULL,
  "Value" TIMESTAMP NOT NULL,
  PRIMARY KEY (CaseCustomTimestampFieldId),
  UNIQUE (CaseId, Name)
);

CREATE INDEX IWA_CaseCstmTmstmpFldValIdx
ON IWA_CaseCustomTimestampField ("Value");


-- Added columns of table IWA_UserSubstitute
ALTER TABLE IWA_UserSubstitute ADD COLUMN
  SubstitutionType INTEGER NOT NULL DEFAULT 0;

-- Create added views
CREATE VIEW IWA_TaskCustomField
(
  TaskId,
  Name,
  "Type",
  StringValue,
  TextValue,
  NumberValue,
  TimestampValue
)
AS
  SELECT
    StringField.TaskId,
    StringField.Name,
    'String',
    StringField."Value",
    NULL::text,
    NULL::numeric,
    NULL::timestamp
  FROM IWA_TaskCustomStringField AS StringField
UNION ALL
  SELECT
    TextField.TaskId,
    TextField.Name,
    'Text',
    NULL::text,
    TextField."Value",
    NULL::numeric,
    NULL::timestamp
  FROM IWA_TaskCustomTextField AS TextField
UNION ALL
  SELECT
    NumberField.TaskId,
    NumberField.Name,
    'Number',
    NULL::text,
    NULL::text,
    NumberField."Value",
    NULL::timestamp
  FROM IWA_TaskCustomNumberField AS NumberField
UNION ALL
  SELECT
    TimestampField.TaskId,
    TimestampField.Name,
    'Timestamp',
    NULL::text,
    NULL::text,
    NULL::numeric,
    TimestampField."Value"
  FROM IWA_TaskCustomTimestampField AS TimestampField;

CREATE VIEW IWA_CaseCustomField
(
  CaseId,
  Name,
  "Type",
  StringValue,
  TextValue,
  NumberValue,
  TimestampValue
)
AS
  SELECT
    StringField.CaseId,
    StringField.Name,
    'String',
    StringField."Value",
    NULL::text,
    NULL::numeric,
    NULL::timestamp
  FROM IWA_CaseCustomStringField AS StringField
UNION ALL
  SELECT
    TextField.CaseId,
    TextField.Name,
    'Text',
    NULL::text,
    TextField."Value",
    NULL::numeric,
    NULL::timestamp
  FROM IWA_CaseCustomTextField AS TextField
UNION ALL
  SELECT
    NumberField.CaseId,
    NumberField.Name,
    'Number',
    NULL::text,
    NULL::text,
    NumberField."Value",
    NULL::timestamp
  FROM IWA_CaseCustomNumberField AS NumberField
UNION ALL
  SELECT
    TimestampField.CaseId,
    TimestampField.Name,
    'Timestamp',
    NULL::text,
    NULL::text,
    NULL::numeric,
    TimestampField."Value"
  FROM IWA_CaseCustomTimestampField AS TimestampField;

-- Delete process models that belong to the SYSTEM application
DELETE FROM IWA_ProcessModel WHERE ApplicationId=0;


-- 
-- Update Version
-- 
UPDATE IWA_Version SET Version=51;
